<?php

// Data functions (insert, update, delete, form) for table akkubetriebskartei

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function akkubetriebskartei_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('akkubetriebskartei');
	if(!$arrPerm['insert']) return false;

	$data = [
		'inventarnummer' => Request::lookup('inventarnummer', ''),
		'kaufdatum' => Request::lookup('inventarnummer'),
		'marke' => Request::lookup('inventarnummer'),
		'kapazitaet' => Request::lookup('inventarnummer'),
		'zellenanzahl' => Request::lookup('inventarnummer'),
		'datum' => mysql_datetime(Request::val('datum', '')),
		'ladung' => Request::val('ladung', ''),
		'bemerkung' => br2nl(Request::val('bemerkung', '')),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];


	// hook: akkubetriebskartei_before_insert
	if(function_exists('akkubetriebskartei_before_insert')) {
		$args = [];
		if(!akkubetriebskartei_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('akkubetriebskartei', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('akkubetriebskartei', $recID, calculated_fields()['akkubetriebskartei']);

	// hook: akkubetriebskartei_after_insert
	if(function_exists('akkubetriebskartei_after_insert')) {
		$res = sql("SELECT * FROM `akkubetriebskartei` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!akkubetriebskartei_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('akkubetriebskartei', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) akkubetriebskartei_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function akkubetriebskartei_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function akkubetriebskartei_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('akkubetriebskartei', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: akkubetriebskartei_before_delete
	if(function_exists('akkubetriebskartei_before_delete')) {
		$args = [];
		if(!akkubetriebskartei_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `akkubetriebskartei` WHERE `id`='{$selected_id}'", $eo);

	// hook: akkubetriebskartei_after_delete
	if(function_exists('akkubetriebskartei_after_delete')) {
		$args = [];
		akkubetriebskartei_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='akkubetriebskartei' AND `pkValue`='{$selected_id}'", $eo);
}

function akkubetriebskartei_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('akkubetriebskartei', $selected_id, 'edit')) return false;

	$data = [
		'inventarnummer' => Request::lookup('inventarnummer', ''),
		'kaufdatum' => Request::lookup('inventarnummer'),
		'marke' => Request::lookup('inventarnummer'),
		'kapazitaet' => Request::lookup('inventarnummer'),
		'zellenanzahl' => Request::lookup('inventarnummer'),
		'datum' => mysql_datetime(Request::val('datum', '')),
		'ladung' => Request::val('ladung', ''),
		'bemerkung' => br2nl(Request::val('bemerkung', '')),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	// get existing values
	$old_data = getRecord('akkubetriebskartei', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: akkubetriebskartei_before_update
	if(function_exists('akkubetriebskartei_before_update')) {
		$args = ['old_data' => $old_data];
		if(!akkubetriebskartei_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'akkubetriebskartei', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="akkubetriebskartei_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('akkubetriebskartei', $data['selectedID'], calculated_fields()['akkubetriebskartei']);

	// hook: akkubetriebskartei_after_update
	if(function_exists('akkubetriebskartei_after_update')) {
		$res = sql("SELECT * FROM `akkubetriebskartei` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!akkubetriebskartei_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='akkubetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function akkubetriebskartei_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('akkubetriebskartei');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}

	$filterer_inventarnummer = Request::val('filterer_inventarnummer');

	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: inventarnummer
	$combo_inventarnummer = new DataCombo;
	// combobox: ladung
	$combo_ladung = new Combo;
	$combo_ladung->ListType = 0;
	$combo_ladung->MultipleSeparator = ', ';
	$combo_ladung->ListBoxHeight = 10;
	$combo_ladung->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/akkubetriebskartei.ladung.csv')) {
		$ladung_data = addslashes(implode('', @file(__DIR__ . '/hooks/akkubetriebskartei.ladung.csv')));
		$combo_ladung->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($ladung_data))));
		$combo_ladung->ListData = $combo_ladung->ListItem;
	} else {
		$combo_ladung->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("laden;;entladen;;auf Lagerspannung gebracht"))));
		$combo_ladung->ListData = $combo_ladung->ListItem;
	}
	$combo_ladung->SelectName = 'ladung';

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='akkubetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='akkubetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `akkubetriebskartei` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'akkubetriebskartei_view.php', false);
		}
		$combo_inventarnummer->SelectedData = $row['inventarnummer'];
		$combo_ladung->SelectedData = $row['ladung'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_inventarnummer->SelectedData = $filterer_inventarnummer;
		$combo_ladung->SelectedText = (isset($filterField[1]) && $filterField[1] == '8' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
	}
	$combo_inventarnummer->HTML = '<span id="inventarnummer-container' . $rnd1 . '"></span><input type="hidden" name="inventarnummer" id="inventarnummer' . $rnd1 . '" value="' . html_attr($combo_inventarnummer->SelectedData) . '">';
	$combo_inventarnummer->MatchText = '<span id="inventarnummer-container-readonly' . $rnd1 . '"></span><input type="hidden" name="inventarnummer" id="inventarnummer' . $rnd1 . '" value="' . html_attr($combo_inventarnummer->SelectedData) . '">';
	$combo_ladung->Render();

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_inventarnummer__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['inventarnummer'] : htmlspecialchars($filterer_inventarnummer, ENT_QUOTES)); ?>"};

		jQuery(function() {
			setTimeout(function() {
				if(typeof(inventarnummer_reload__RAND__) == 'function') inventarnummer_reload__RAND__();
			}, 50); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function inventarnummer_reload__RAND__() {
		<?php if(($AllowUpdate || ($arrPerm['insert'] && !$selected_id)) && !$dvprint) { ?>

			$j("#inventarnummer-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c) {
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_inventarnummer__RAND__.value, t: 'akkubetriebskartei', f: 'inventarnummer' },
						success: function(resp) {
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="inventarnummer"]').val(resp.results[0].id);
							$j('[id=inventarnummer-container-readonly__RAND__]').html('<span class="match-text" id="inventarnummer-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=akkus_view_parent]').hide(); } else { $j('.btn[id=akkus_view_parent]').show(); }


							if(typeof(inventarnummer_update_autofills__RAND__) == 'function') inventarnummer_update_autofills__RAND__();
						}
					});
				},
				width: '100%',
				formatNoMatches: function(term) { return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 5,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page) { return { s: term, p: page, t: 'akkubetriebskartei', f: 'inventarnummer' }; },
					results: function(resp, page) { return resp; }
				},
				escapeMarkup: function(str) { return str; }
			}).on('change', function(e) {
				AppGini.current_inventarnummer__RAND__.value = e.added.id;
				AppGini.current_inventarnummer__RAND__.text = e.added.text;
				$j('[name="inventarnummer"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=akkus_view_parent]').hide(); } else { $j('.btn[id=akkus_view_parent]').show(); }


				if(typeof(inventarnummer_update_autofills__RAND__) == 'function') inventarnummer_update_autofills__RAND__();
			});

			if(!$j("#inventarnummer-container__RAND__").length) {
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_inventarnummer__RAND__.value, t: 'akkubetriebskartei', f: 'inventarnummer' },
					success: function(resp) {
						$j('[name="inventarnummer"]').val(resp.results[0].id);
						$j('[id=inventarnummer-container-readonly__RAND__]').html('<span class="match-text" id="inventarnummer-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=akkus_view_parent]').hide(); } else { $j('.btn[id=akkus_view_parent]').show(); }

						if(typeof(inventarnummer_update_autofills__RAND__) == 'function') inventarnummer_update_autofills__RAND__();
					}
				});
			}

		<?php } else { ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_inventarnummer__RAND__.value, t: 'akkubetriebskartei', f: 'inventarnummer' },
				success: function(resp) {
					$j('[id=inventarnummer-container__RAND__], [id=inventarnummer-container-readonly__RAND__]').html('<span class="match-text" id="inventarnummer-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=akkus_view_parent]').hide(); } else { $j('.btn[id=akkus_view_parent]').show(); }

					if(typeof(inventarnummer_update_autofills__RAND__) == 'function') inventarnummer_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_clean());


	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/akkubetriebskartei_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/akkubetriebskartei_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Akku Betriebsaufzeichnung', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return akkubetriebskartei_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return akkubetriebskartei_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return akkubetriebskartei_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#inventarnummer').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#inventarnummer_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#datum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"datum\">' + (jQuery('#datum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#ladung').replaceWith('<div class=\"form-control-static\" id=\"ladung\">' + (jQuery('#ladung').val() || '') + '</div>'); jQuery('#ladung-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#bemerkung').replaceWith('<div class=\"form-control-static\" id=\"bemerkung\">' + (jQuery('#bemerkung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#datum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(inventarnummer)%%>', $combo_inventarnummer->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(inventarnummer)%%>', $combo_inventarnummer->MatchText, $templateCode);
	$templateCode = str_replace('<%%URLCOMBOTEXT(inventarnummer)%%>', urlencode($combo_inventarnummer->MatchText), $templateCode);
	$templateCode = str_replace('<%%COMBO(ladung)%%>', $combo_ladung->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(ladung)%%>', $combo_ladung->SelectedData, $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = ['inventarnummer' => ['akkus', 'Inventarnummer'], ];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(inventarnummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(ladung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bemerkung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', safe_html($urow['inventarnummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', html_attr($row['inventarnummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode($urow['inventarnummer']), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', app_datetime($row['datum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(app_datetime($urow['datum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(ladung)%%>', safe_html($urow['ladung']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(ladung)%%>', html_attr($row['ladung']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ladung)%%>', urlencode($urow['ladung']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(bemerkung)%%>', safe_html($urow['bemerkung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(bemerkung)%%>', safe_html($urow['bemerkung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(bemerkung)%%>', urlencode($urow['bemerkung']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(inventarnummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(ladung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ladung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bemerkung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bemerkung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';

	$templateCode .= "\tinventarnummer_update_autofills$rnd1 = function() {\n";
	$templateCode .= "\t\t\$j.ajax({\n";
	if($dvprint) {
		$templateCode .= "\t\t\turl: 'akkubetriebskartei_autofill.php?rnd1=$rnd1&mfk=inventarnummer&id=' + encodeURIComponent('".addslashes($row['inventarnummer'])."'),\n";
		$templateCode .= "\t\t\tcontentType: 'application/x-www-form-urlencoded; charset=" . datalist_db_encoding . "',\n";
		$templateCode .= "\t\t\ttype: 'GET'\n";
	} else {
		$templateCode .= "\t\t\turl: 'akkubetriebskartei_autofill.php?rnd1=$rnd1&mfk=inventarnummer&id=' + encodeURIComponent(AppGini.current_inventarnummer{$rnd1}.value),\n";
		$templateCode .= "\t\t\tcontentType: 'application/x-www-form-urlencoded; charset=" . datalist_db_encoding . "',\n";
		$templateCode .= "\t\t\ttype: 'GET',\n";
		$templateCode .= "\t\t\tbeforeSend: function() { \$j('#inventarnummer$rnd1').prop('disabled', true); },\n";
		$templateCode .= "\t\t\tcomplete: function() { " . (($arrPerm['insert'] || (($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3)) ? "\$j('#inventarnummer$rnd1').prop('disabled', false); " : "\$j('#inventarnummer$rnd1').prop('disabled', true); ")." \$j(window).resize(); }\n";
	}
	$templateCode .= "\t\t});\n";
	$templateCode .= "\t};\n";
	if(!$dvprint) $templateCode .= "\tif(\$j('#inventarnummer_caption').length) \$j('#inventarnummer_caption').click(function() { inventarnummer_update_autofills$rnd1(); });\n";


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('akkubetriebskartei');
	if($selected_id) {
		$jdata = get_joined_record('akkubetriebskartei', $selected_id);
		if($jdata === false) $jdata = get_defaults('akkubetriebskartei');
		$rdata = $row;
	}
	$templateCode .= loadView('akkubetriebskartei-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: akkubetriebskartei_dv
	if(function_exists('akkubetriebskartei_dv')) {
		$args = [];
		akkubetriebskartei_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}