<?php

// Data functions (insert, update, delete, form) for table akkus

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function akkus_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('akkus');
	if(!$arrPerm['insert']) return false;

	$data = [
		'inventarnummer' => Request::val('inventarnummer', ''),
		'kaufdatum' => mysql_datetime(Request::val('kaufdatum', '')),
		'kaufpreis' => Request::val('kaufpreis', ''),
		'marke' => Request::val('marke', ''),
		'kapazitaet' => Request::val('kapazitaet', ''),
		'zellenanzahl' => Request::val('zellenanzahl', ''),
		'technische_daten' => Request::val('technische_daten', ''),
		'anmerkungen' => br2nl(Request::val('anmerkungen', '')),
		'datei1' => Request::fileUpload('datei1', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('akkus', 'datei1', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];


	// hook: akkus_before_insert
	if(function_exists('akkus_before_insert')) {
		$args = [];
		if(!akkus_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('akkus', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('akkus', $recID, calculated_fields()['akkus']);

	// hook: akkus_after_insert
	if(function_exists('akkus_after_insert')) {
		$res = sql("SELECT * FROM `akkus` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!akkus_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('akkus', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) akkus_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function akkus_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function akkus_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('akkus', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: akkus_before_delete
	if(function_exists('akkus_before_delete')) {
		$args = [];
		if(!akkus_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	// child table: akkubetriebskartei
	$res = sql("SELECT `id` FROM `akkus` WHERE `id`='{$selected_id}'", $eo);
	$id = db_fetch_row($res);
	$rires = sql("SELECT COUNT(1) FROM `akkubetriebskartei` WHERE `inventarnummer`='" . makeSafe($id[0]) . "'", $eo);
	$rirow = db_fetch_row($rires);
	if($rirow[0] && !$AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation["couldn't delete"];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'akkubetriebskartei', $RetMsg);
		return $RetMsg;
	} elseif($rirow[0] && $AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation['confirm delete'];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'akkubetriebskartei', $RetMsg);
		$RetMsg = str_replace('<Delete>', '<input type="button" class="btn btn-danger" value="' . html_attr($Translation['yes']) . '" onClick="window.location = \'akkus_view.php?SelectedID=' . urlencode($selected_id) . '&delete_x=1&confirmed=1&csrf_token=' . urlencode(csrf_token(false, true)) . '\';">', $RetMsg);
		$RetMsg = str_replace('<Cancel>', '<input type="button" class="btn btn-success" value="' . html_attr($Translation[ 'no']) . '" onClick="window.location = \'akkus_view.php?SelectedID=' . urlencode($selected_id) . '\';">', $RetMsg);
		return $RetMsg;
	}

	sql("DELETE FROM `akkus` WHERE `id`='{$selected_id}'", $eo);

	// hook: akkus_after_delete
	if(function_exists('akkus_after_delete')) {
		$args = [];
		akkus_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='akkus' AND `pkValue`='{$selected_id}'", $eo);
}

function akkus_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('akkus', $selected_id, 'edit')) return false;

	$data = [
		'inventarnummer' => Request::val('inventarnummer', ''),
		'kaufdatum' => mysql_datetime(Request::val('kaufdatum', '')),
		'kaufpreis' => Request::val('kaufpreis', ''),
		'marke' => Request::val('marke', ''),
		'kapazitaet' => Request::val('kapazitaet', ''),
		'zellenanzahl' => Request::val('zellenanzahl', ''),
		'technische_daten' => Request::val('technische_daten', ''),
		'anmerkungen' => br2nl(Request::val('anmerkungen', '')),
		'datei1' => Request::fileUpload('datei1', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('akkus', 'datei1', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	// get existing values
	$old_data = getRecord('akkus', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: akkus_before_update
	if(function_exists('akkus_before_update')) {
		$args = ['old_data' => $old_data];
		if(!akkus_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'akkus', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="akkus_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('akkus', $data['selectedID'], calculated_fields()['akkus']);

	// hook: akkus_after_update
	if(function_exists('akkus_after_update')) {
		$res = sql("SELECT * FROM `akkus` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!akkus_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='akkus' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function akkus_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('akkus');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='akkus' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='akkus' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `akkus` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'akkus_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
	}

	ob_start();
	?>

	<script>
		// initial lookup values

		jQuery(function() {
			setTimeout(function() {
			}, 50); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_clean());


	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/akkus_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/akkus_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Mein Akku', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return akkus_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return akkus_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return akkus_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#inventarnummer').replaceWith('<div class=\"form-control-static\" id=\"inventarnummer\">' + (jQuery('#inventarnummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kaufdatum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"kaufdatum\">' + (jQuery('#kaufdatum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kaufpreis').replaceWith('<div class=\"form-control-static\" id=\"kaufpreis\">' + (jQuery('#kaufpreis').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#marke').replaceWith('<div class=\"form-control-static\" id=\"marke\">' + (jQuery('#marke').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kapazitaet').replaceWith('<div class=\"form-control-static\" id=\"kapazitaet\">' + (jQuery('#kapazitaet').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#zellenanzahl').replaceWith('<div class=\"form-control-static\" id=\"zellenanzahl\">' + (jQuery('#zellenanzahl').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#technische_daten').replaceWith('<div class=\"form-control-static\" id=\"technische_daten\">' + (jQuery('#technische_daten').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anmerkungen').replaceWith('<div class=\"form-control-static\" id=\"anmerkungen\">' + (jQuery('#anmerkungen').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei1').replaceWith('<div class=\"form-control-static\" id=\"datei1\">' + (jQuery('#datei1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei1, #datei1-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#kaufdatum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(inventarnummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kaufdatum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kaufpreis)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(marke)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kapazitaet)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(zellenanzahl)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(technische_daten)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(anmerkungen)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datei1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei1" id="datei1" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2048000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei1)%%>', '<br><input type="checkbox" name="datei1_remove" id="datei1_remove" value="1"> <label for="datei1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', safe_html($urow['inventarnummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', html_attr($row['inventarnummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode($urow['inventarnummer']), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufdatum)%%>', app_datetime($row['kaufdatum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufdatum)%%>', urlencode(app_datetime($urow['kaufdatum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(kaufpreis)%%>', safe_html($urow['kaufpreis']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(kaufpreis)%%>', html_attr($row['kaufpreis']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufpreis)%%>', urlencode($urow['kaufpreis']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(marke)%%>', safe_html($urow['marke']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(marke)%%>', html_attr($row['marke']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(marke)%%>', urlencode($urow['marke']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(kapazitaet)%%>', safe_html($urow['kapazitaet']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(kapazitaet)%%>', html_attr($row['kapazitaet']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kapazitaet)%%>', urlencode($urow['kapazitaet']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(zellenanzahl)%%>', safe_html($urow['zellenanzahl']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(zellenanzahl)%%>', html_attr($row['zellenanzahl']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(zellenanzahl)%%>', urlencode($urow['zellenanzahl']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(technische_daten)%%>', safe_html($urow['technische_daten']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(technische_daten)%%>', html_attr($row['technische_daten']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(technische_daten)%%>', urlencode($urow['technische_daten']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(anmerkungen)%%>', safe_html($urow['anmerkungen']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(anmerkungen)%%>', safe_html($urow['anmerkungen'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(anmerkungen)%%>', urlencode($urow['anmerkungen']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei1)%%>', safe_html($urow['datei1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei1)%%>', html_attr($row['datei1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei1)%%>', urlencode($urow['datei1']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(inventarnummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufdatum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufdatum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufpreis)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufpreis)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(marke)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(marke)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kapazitaet)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kapazitaet)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(zellenanzahl)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(zellenanzahl)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(technische_daten)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(technische_daten)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anmerkungen)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anmerkungen)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei1)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei1)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('datei1Edit')) { document.getElementById('datei1Edit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('datei1EditLink')) { document.getElementById('datei1EditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('akkus');
	if($selected_id) {
		$jdata = get_joined_record('akkus', $selected_id);
		if($jdata === false) $jdata = get_defaults('akkus');
		$rdata = $row;
	}
	$templateCode .= loadView('akkus-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: akkus_dv
	if(function_exists('akkus_dv')) {
		$args = [];
		akkus_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}