<?php

// Data functions (insert, update, delete, form) for table checklisten

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function checklisten_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('checklisten');
	if(!$arrPerm['insert']) return false;

	$data = [
		'checklistennummer' => Request::val('checklistennummer', ''),
		'gewicht' => Request::val('gewicht', ''),
		'modellname' => Request::lookup('modellname', ''),
		'hersteller' => Request::lookup('modellname'),
		'modelltyp' => Request::lookup('modellname'),
		'datei1' => Request::fileUpload('datei1', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('checklisten', 'datei1', Request::val('SelectedID'));
			},
		]),
		'datei2' => Request::fileUpload('datei2', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('checklisten', 'datei2', Request::val('SelectedID'));
			},
		]),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild1', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('checklisten', 'bild1', Request::val('SelectedID'));
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild2', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('checklisten', 'bild2', Request::val('SelectedID'));
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild3', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('checklisten', 'bild3', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];

	if($data['gewicht'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Gewicht': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}

	// hook: checklisten_before_insert
	if(function_exists('checklisten_before_insert')) {
		$args = [];
		if(!checklisten_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('checklisten', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('checklisten', $recID, calculated_fields()['checklisten']);

	// hook: checklisten_after_insert
	if(function_exists('checklisten_after_insert')) {
		$res = sql("SELECT * FROM `checklisten` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!checklisten_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('checklisten', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) checklisten_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function checklisten_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function checklisten_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('checklisten', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: checklisten_before_delete
	if(function_exists('checklisten_before_delete')) {
		$args = [];
		if(!checklisten_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `checklisten` WHERE `id`='{$selected_id}'", $eo);

	// hook: checklisten_after_delete
	if(function_exists('checklisten_after_delete')) {
		$args = [];
		checklisten_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='checklisten' AND `pkValue`='{$selected_id}'", $eo);
}

function checklisten_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('checklisten', $selected_id, 'edit')) return false;

	$data = [
		'checklistennummer' => Request::val('checklistennummer', ''),
		'gewicht' => Request::val('gewicht', ''),
		'modellname' => Request::lookup('modellname', ''),
		'hersteller' => Request::lookup('modellname'),
		'modelltyp' => Request::lookup('modellname'),
		'datei1' => Request::fileUpload('datei1', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('checklisten', 'datei1', $selected_id);
			},
		]),
		'datei2' => Request::fileUpload('datei2', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('checklisten', 'datei2', $selected_id);
			},
		]),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild1', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('checklisten', 'bild1', $selected_id);
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild2', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('checklisten', 'bild2', $selected_id);
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('checklisten', 'bild3', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('checklisten', 'bild3', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	if($data['gewicht'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Gewicht': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	// get existing values
	$old_data = getRecord('checklisten', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: checklisten_before_update
	if(function_exists('checklisten_before_update')) {
		$args = ['old_data' => $old_data];
		if(!checklisten_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'checklisten', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="checklisten_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('checklisten', $data['selectedID'], calculated_fields()['checklisten']);

	// hook: checklisten_after_update
	if(function_exists('checklisten_after_update')) {
		$res = sql("SELECT * FROM `checklisten` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!checklisten_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='checklisten' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function checklisten_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('checklisten');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}

	$filterer_modellname = Request::val('filterer_modellname');

	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: gewicht
	$combo_gewicht = new Combo;
	$combo_gewicht->ListType = 0;
	$combo_gewicht->MultipleSeparator = ', ';
	$combo_gewicht->ListBoxHeight = 10;
	$combo_gewicht->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/checklisten.gewicht.csv')) {
		$gewicht_data = addslashes(implode('', @file(__DIR__ . '/hooks/checklisten.gewicht.csv')));
		$combo_gewicht->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($gewicht_data))));
		$combo_gewicht->ListData = $combo_gewicht->ListItem;
	} else {
		$combo_gewicht->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("kleiner 25 kg;;gr&#246;&#223;er 25 kg"))));
		$combo_gewicht->ListData = $combo_gewicht->ListItem;
	}
	$combo_gewicht->SelectName = 'gewicht';
	$combo_gewicht->AllowNull = false;
	// combobox: modellname
	$combo_modellname = new DataCombo;

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='checklisten' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='checklisten' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `checklisten` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'checklisten_view.php', false);
		}
		$combo_gewicht->SelectedData = $row['gewicht'];
		$combo_modellname->SelectedData = $row['modellname'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_gewicht->SelectedText = (isset($filterField[1]) && $filterField[1] == '3' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
		$combo_modellname->SelectedData = $filterer_modellname;
	}
	$combo_gewicht->Render();
	$combo_modellname->HTML = '<span id="modellname-container' . $rnd1 . '"></span><input type="hidden" name="modellname" id="modellname' . $rnd1 . '" value="' . html_attr($combo_modellname->SelectedData) . '">';
	$combo_modellname->MatchText = '<span id="modellname-container-readonly' . $rnd1 . '"></span><input type="hidden" name="modellname" id="modellname' . $rnd1 . '" value="' . html_attr($combo_modellname->SelectedData) . '">';

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_modellname__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['modellname'] : htmlspecialchars($filterer_modellname, ENT_QUOTES)); ?>"};

		jQuery(function() {
			setTimeout(function() {
				if(typeof(modellname_reload__RAND__) == 'function') modellname_reload__RAND__();
			}, 50); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function modellname_reload__RAND__() {
		<?php if(($AllowUpdate || ($arrPerm['insert'] && !$selected_id)) && !$dvprint) { ?>

			$j("#modellname-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c) {
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_modellname__RAND__.value, t: 'checklisten', f: 'modellname' },
						success: function(resp) {
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="modellname"]').val(resp.results[0].id);
							$j('[id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }


							if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
						}
					});
				},
				width: '100%',
				formatNoMatches: function(term) { return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 5,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page) { return { s: term, p: page, t: 'checklisten', f: 'modellname' }; },
					results: function(resp, page) { return resp; }
				},
				escapeMarkup: function(str) { return str; }
			}).on('change', function(e) {
				AppGini.current_modellname__RAND__.value = e.added.id;
				AppGini.current_modellname__RAND__.text = e.added.text;
				$j('[name="modellname"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }


				if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
			});

			if(!$j("#modellname-container__RAND__").length) {
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_modellname__RAND__.value, t: 'checklisten', f: 'modellname' },
					success: function(resp) {
						$j('[name="modellname"]').val(resp.results[0].id);
						$j('[id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }

						if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
					}
				});
			}

		<?php } else { ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_modellname__RAND__.value, t: 'checklisten', f: 'modellname' },
				success: function(resp) {
					$j('[id=modellname-container__RAND__], [id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }

					if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_clean());


	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/checklisten_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/checklisten_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Checkliste', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return checklisten_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return checklisten_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return checklisten_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#checklistennummer').replaceWith('<div class=\"form-control-static\" id=\"checklistennummer\">' + (jQuery('#checklistennummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#gewicht').replaceWith('<div class=\"form-control-static\" id=\"gewicht\">' + (jQuery('#gewicht').val() || '') + '</div>'); jQuery('#gewicht-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#modellname').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#modellname_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#datei1').replaceWith('<div class=\"form-control-static\" id=\"datei1\">' + (jQuery('#datei1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei1, #datei1-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#datei2').replaceWith('<div class=\"form-control-static\" id=\"datei2\">' + (jQuery('#datei2').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei2, #datei2-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#bild1').replaceWith('<div class=\"form-control-static\" id=\"bild1\">' + (jQuery('#bild1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild2').replaceWith('<div class=\"form-control-static\" id=\"bild2\">' + (jQuery('#bild2').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild3').replaceWith('<div class=\"form-control-static\" id=\"bild3\">' + (jQuery('#bild3').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(gewicht)%%>', $combo_gewicht->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(gewicht)%%>', $combo_gewicht->SelectedData, $templateCode);
	$templateCode = str_replace('<%%COMBO(modellname)%%>', $combo_modellname->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(modellname)%%>', $combo_modellname->MatchText, $templateCode);
	$templateCode = str_replace('<%%URLCOMBOTEXT(modellname)%%>', urlencode($combo_modellname->MatchText), $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = ['modellname' => ['modelle', 'Modellname'], ];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(checklistennummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(gewicht)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(modellname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datei1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei1" id="datei1" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2048000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei1)%%>', '<br><input type="checkbox" name="datei1_remove" id="datei1_remove" value="1"> <label for="datei1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(datei2)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei2" id="datei2" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2048000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei2'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei2)%%>', '<br><input type="checkbox" name="datei2_remove" id="datei2_remove" value="1"> <label for="datei2_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei2)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild1" id="bild1" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '<br><input type="checkbox" name="bild1_remove" id="bild1_remove" value="1"> <label for="bild1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild2)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild2" id="bild2" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild2'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '<br><input type="checkbox" name="bild2_remove" id="bild2_remove" value="1"> <label for="bild2_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild3)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild3" id="bild3" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild3'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '<br><input type="checkbox" name="bild3_remove" id="bild3_remove" value="1"> <label for="bild3_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(checklistennummer)%%>', safe_html($urow['checklistennummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(checklistennummer)%%>', html_attr($row['checklistennummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(checklistennummer)%%>', urlencode($urow['checklistennummer']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(gewicht)%%>', safe_html($urow['gewicht']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(gewicht)%%>', html_attr($row['gewicht']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(gewicht)%%>', urlencode($urow['gewicht']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', safe_html($urow['modellname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', html_attr($row['modellname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode($urow['modellname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei1)%%>', safe_html($urow['datei1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei1)%%>', html_attr($row['datei1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei1)%%>', urlencode($urow['datei1']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei2)%%>', safe_html($urow['datei2']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei2)%%>', html_attr($row['datei2']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei2)%%>', urlencode($urow['datei2']), $templateCode);
		$row['bild1'] = ($row['bild1'] != '' ? $row['bild1'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', safe_html($urow['bild1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', html_attr($row['bild1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild1)%%>', urlencode($urow['bild1']), $templateCode);
		$row['bild2'] = ($row['bild2'] != '' ? $row['bild2'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', safe_html($urow['bild2']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', html_attr($row['bild2']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild2)%%>', urlencode($urow['bild2']), $templateCode);
		$row['bild3'] = ($row['bild3'] != '' ? $row['bild3'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', safe_html($urow['bild3']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', html_attr($row['bild3']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild3)%%>', urlencode($urow['bild3']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(checklistennummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(checklistennummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(gewicht)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(gewicht)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(modellname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei1)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei1)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei2)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei2)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bild1)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild2)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild3)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('datei1Edit')) { document.getElementById('datei1Edit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('datei1EditLink')) { document.getElementById('datei1EditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('datei2Edit')) { document.getElementById('datei2Edit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('datei2EditLink')) { document.getElementById('datei2EditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';

	$templateCode .= "\tmodellname_update_autofills$rnd1 = function() {\n";
	$templateCode .= "\t\t\$j.ajax({\n";
	if($dvprint) {
		$templateCode .= "\t\t\turl: 'checklisten_autofill.php?rnd1=$rnd1&mfk=modellname&id=' + encodeURIComponent('".addslashes($row['modellname'])."'),\n";
		$templateCode .= "\t\t\tcontentType: 'application/x-www-form-urlencoded; charset=" . datalist_db_encoding . "',\n";
		$templateCode .= "\t\t\ttype: 'GET'\n";
	} else {
		$templateCode .= "\t\t\turl: 'checklisten_autofill.php?rnd1=$rnd1&mfk=modellname&id=' + encodeURIComponent(AppGini.current_modellname{$rnd1}.value),\n";
		$templateCode .= "\t\t\tcontentType: 'application/x-www-form-urlencoded; charset=" . datalist_db_encoding . "',\n";
		$templateCode .= "\t\t\ttype: 'GET',\n";
		$templateCode .= "\t\t\tbeforeSend: function() { \$j('#modellname$rnd1').prop('disabled', true); },\n";
		$templateCode .= "\t\t\tcomplete: function() { " . (($arrPerm['insert'] || (($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3)) ? "\$j('#modellname$rnd1').prop('disabled', false); " : "\$j('#modellname$rnd1').prop('disabled', true); ")." \$j(window).resize(); }\n";
	}
	$templateCode .= "\t\t});\n";
	$templateCode .= "\t};\n";
	if(!$dvprint) $templateCode .= "\tif(\$j('#modellname_caption').length) \$j('#modellname_caption').click(function() { modellname_update_autofills$rnd1(); });\n";


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('checklisten');
	if($selected_id) {
		$jdata = get_joined_record('checklisten', $selected_id);
		if($jdata === false) $jdata = get_defaults('checklisten');
		$rdata = $row;
	}
	$templateCode .= loadView('checklisten-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: checklisten_dv
	if(function_exists('checklisten_dv')) {
		$args = [];
		checklisten_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}