<?php

// Data functions (insert, update, delete, form) for table flugbuch_verein

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function flugbuch_verein_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('flugbuch_verein');
	if(!$arrPerm['insert']) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'beginn' => Request::val('beginn', ''),
		'ende' => Request::val('ende', ''),
		'pilot' => Request::val('pilot', ''),
		'anzahl_fluege' => Request::val('anzahl_fluege', ''),
		'anzahl_fluege_120' => Request::val('anzahl_fluege_120', ''),
		'flugplatz' => Request::val('flugplatz', ''),
		'luftraumbeobachter' => Request::val('luftraumbeobachter', ''),
		'besonderheiten' => br2nl(Request::val('besonderheiten', '')),
		'gastpilot' => Request::checkBox('gastpilot', ''),
		'name_gastpilot' => Request::val('name_gastpilot', ''),
		'reg_nr' => Request::val('reg_nr', ''),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugbuch_verein', 'datei', Request::val('SelectedID'));
			},
		]),
		'datei_1' => Request::fileUpload('datei_1', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugbuch_verein', 'datei_1', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true, true),
	];


	// hook: flugbuch_verein_before_insert
	if(function_exists('flugbuch_verein_before_insert')) {
		$args = [];
		if(!flugbuch_verein_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('flugbuch_verein', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('flugbuch_verein', $recID, calculated_fields()['flugbuch_verein']);

	// hook: flugbuch_verein_after_insert
	if(function_exists('flugbuch_verein_after_insert')) {
		$res = sql("SELECT * FROM `flugbuch_verein` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!flugbuch_verein_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('flugbuch_verein', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) flugbuch_verein_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function flugbuch_verein_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function flugbuch_verein_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('flugbuch_verein', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: flugbuch_verein_before_delete
	if(function_exists('flugbuch_verein_before_delete')) {
		$args = [];
		if(!flugbuch_verein_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `flugbuch_verein` WHERE `id`='{$selected_id}'", $eo);

	// hook: flugbuch_verein_after_delete
	if(function_exists('flugbuch_verein_after_delete')) {
		$args = [];
		flugbuch_verein_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='flugbuch_verein' AND `pkValue`='{$selected_id}'", $eo);
}

function flugbuch_verein_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('flugbuch_verein', $selected_id, 'edit')) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'beginn' => Request::val('beginn', ''),
		'ende' => Request::val('ende', ''),
		'pilot' => Request::val('pilot', ''),
		'anzahl_fluege' => Request::val('anzahl_fluege', ''),
		'anzahl_fluege_120' => Request::val('anzahl_fluege_120', ''),
		'flugplatz' => Request::val('flugplatz', ''),
		'luftraumbeobachter' => Request::val('luftraumbeobachter', ''),
		'besonderheiten' => br2nl(Request::val('besonderheiten', '')),
		'gastpilot' => Request::checkBox('gastpilot', ''),
		'name_gastpilot' => Request::val('name_gastpilot', ''),
		'reg_nr' => Request::val('reg_nr', ''),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugbuch_verein', 'datei', $selected_id);
			},
		]),
		'datei_1' => Request::fileUpload('datei_1', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugbuch_verein', 'datei_1', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false, true),
	];

	// get existing values
	$old_data = getRecord('flugbuch_verein', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: flugbuch_verein_before_update
	if(function_exists('flugbuch_verein_before_update')) {
		$args = ['old_data' => $old_data];
		if(!flugbuch_verein_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'flugbuch_verein', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="flugbuch_verein_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('flugbuch_verein', $data['selectedID'], calculated_fields()['flugbuch_verein']);

	// hook: flugbuch_verein_after_update
	if(function_exists('flugbuch_verein_after_update')) {
		$res = sql("SELECT * FROM `flugbuch_verein` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!flugbuch_verein_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='flugbuch_verein' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function flugbuch_verein_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('flugbuch_verein');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='flugbuch_verein' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='flugbuch_verein' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `flugbuch_verein` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'flugbuch_verein_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
	}

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/flugbuch_verein_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/flugbuch_verein_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Flugbucheintrag', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return flugbuch_verein_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return flugbuch_verein_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return flugbuch_verein_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#datum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"datum\">' + (jQuery('#datum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#beginn').replaceWith('<div class=\"form-control-static\" id=\"beginn\">' + (jQuery('#beginn').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#ende').replaceWith('<div class=\"form-control-static\" id=\"ende\">' + (jQuery('#ende').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#pilot').replaceWith('<div class=\"form-control-static\" id=\"pilot\">' + (jQuery('#pilot').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anzahl_fluege').replaceWith('<div class=\"form-control-static\" id=\"anzahl_fluege\">' + (jQuery('#anzahl_fluege').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anzahl_fluege_120').replaceWith('<div class=\"form-control-static\" id=\"anzahl_fluege_120\">' + (jQuery('#anzahl_fluege_120').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#flugplatz').replaceWith('<div class=\"form-control-static\" id=\"flugplatz\">' + (jQuery('#flugplatz').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#luftraumbeobachter').replaceWith('<div class=\"form-control-static\" id=\"luftraumbeobachter\">' + (jQuery('#luftraumbeobachter').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#besonderheiten').replaceWith('<div class=\"form-control-static\" id=\"besonderheiten\">' + (jQuery('#besonderheiten').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#gastpilot').prop('disabled', true);\n";
		$jsReadOnly .= "\tjQuery('#name_gastpilot').replaceWith('<div class=\"form-control-static\" id=\"name_gastpilot\">' + (jQuery('#name_gastpilot').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#reg_nr').replaceWith('<div class=\"form-control-static\" id=\"reg_nr\">' + (jQuery('#reg_nr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei').replaceWith('<div class=\"form-control-static\" id=\"datei\">' + (jQuery('#datei').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei, #datei-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#datei_1').replaceWith('<div class=\"form-control-static\" id=\"datei_1\">' + (jQuery('#datei_1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei_1, #datei_1-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#datum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('#beginn').addClass('always_shown').timepicker({ defaultTime: false, showSeconds: true, showMeridian: false, showInputs: false, disableFocus: true, minuteStep: 5 });";
		$jsEditable .= "\tjQuery('#ende').addClass('always_shown').timepicker({ defaultTime: false, showSeconds: true, showMeridian: false, showInputs: false, disableFocus: true, minuteStep: 5 });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beginn)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(ende)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(pilot)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(anzahl_fluege)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(anzahl_fluege_120)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(flugplatz)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(luftraumbeobachter)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(besonderheiten)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(gastpilot)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(name_gastpilot)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(reg_nr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datei)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei" id="datei" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2560000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '<br><input type="checkbox" name="datei_remove" id="datei_remove" value="1"> <label for="datei_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(datei_1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei_1" id="datei_1" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2560000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei_1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei_1)%%>', '<br><input type="checkbox" name="datei_1_remove" id="datei_1_remove" value="1"> <label for="datei_1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei_1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', app_datetime($row['datum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(app_datetime($urow['datum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(beginn)%%>', safe_html($urow['beginn']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(beginn)%%>', html_attr($row['beginn']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beginn)%%>', urlencode($urow['beginn']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(ende)%%>', safe_html($urow['ende']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(ende)%%>', html_attr($row['ende']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ende)%%>', urlencode($urow['ende']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(pilot)%%>', safe_html($urow['pilot']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(pilot)%%>', html_attr($row['pilot']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(pilot)%%>', urlencode($urow['pilot']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(anzahl_fluege)%%>', safe_html($urow['anzahl_fluege']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(anzahl_fluege)%%>', html_attr($row['anzahl_fluege']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anzahl_fluege)%%>', urlencode($urow['anzahl_fluege']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(anzahl_fluege_120)%%>', safe_html($urow['anzahl_fluege_120']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(anzahl_fluege_120)%%>', html_attr($row['anzahl_fluege_120']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anzahl_fluege_120)%%>', urlencode($urow['anzahl_fluege_120']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(flugplatz)%%>', safe_html($urow['flugplatz']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(flugplatz)%%>', html_attr($row['flugplatz']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugplatz)%%>', urlencode($urow['flugplatz']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(luftraumbeobachter)%%>', safe_html($urow['luftraumbeobachter']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(luftraumbeobachter)%%>', html_attr($row['luftraumbeobachter']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(luftraumbeobachter)%%>', urlencode($urow['luftraumbeobachter']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(besonderheiten)%%>', safe_html($urow['besonderheiten']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(besonderheiten)%%>', safe_html($urow['besonderheiten'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(besonderheiten)%%>', urlencode($urow['besonderheiten']), $templateCode);
		$templateCode = str_replace('<%%CHECKED(gastpilot)%%>', ($row['gastpilot'] ? "checked" : ""), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(name_gastpilot)%%>', safe_html($urow['name_gastpilot']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(name_gastpilot)%%>', html_attr($row['name_gastpilot']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(name_gastpilot)%%>', urlencode($urow['name_gastpilot']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(reg_nr)%%>', safe_html($urow['reg_nr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(reg_nr)%%>', html_attr($row['reg_nr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(reg_nr)%%>', urlencode($urow['reg_nr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', safe_html($urow['datei']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', html_attr($row['datei']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode($urow['datei']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei_1)%%>', safe_html($urow['datei_1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei_1)%%>', html_attr($row['datei_1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei_1)%%>', urlencode($urow['datei_1']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', app_datetime($row['erfasst'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode(app_datetime($urow['erfasst'], 'dt')), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', app_datetime($row['geaendert'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode(app_datetime($urow['geaendert'], 'dt')), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beginn)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beginn)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(ende)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ende)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(pilot)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(pilot)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anzahl_fluege)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anzahl_fluege)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anzahl_fluege_120)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anzahl_fluege_120)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(flugplatz)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugplatz)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(luftraumbeobachter)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(luftraumbeobachter)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(besonderheiten)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(besonderheiten)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%CHECKED(gastpilot)%%>', '', $templateCode);
		$templateCode = str_replace('<%%VALUE(name_gastpilot)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(name_gastpilot)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(reg_nr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(reg_nr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei_1)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei_1)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('dateiEdit')) { document.getElementById('dateiEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('dateiEditLink')) { document.getElementById('dateiEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('datei_1Edit')) { document.getElementById('datei_1Edit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('datei_1EditLink')) { document.getElementById('datei_1EditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('flugbuch_verein');
	if($selected_id) {
		$jdata = get_joined_record('flugbuch_verein', $selected_id);
		if($jdata === false) $jdata = get_defaults('flugbuch_verein');
		$rdata = $row;
	}
	$templateCode .= loadView('flugbuch_verein-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: flugbuch_verein_dv
	if(function_exists('flugbuch_verein_dv')) {
		$args = [];
		flugbuch_verein_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}