<?php

// Data functions (insert, update, delete, form) for table flugplaetze_oe

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function flugplaetze_oe_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('flugplaetze_oe');
	if(!$arrPerm['insert']) return false;

	$data = [
		'flugplatznummer' => Request::val('flugplatznummer', ''),
		'artikel_16' => Request::val('artikel_16', ''),
		'vereinsname' => Request::val('vereinsname', ''),
		'bundesland' => Request::val('bundesland', ''),
		'telefon' => Request::val('telefon', ''),
		'vorname' => Request::val('vorname', ''),
		'nachname' => Request::val('nachname', ''),
		'email' => Request::val('email', ''),
		'zvr' => Request::val('zvr', ''),
		'flughoehe' => Request::val('flughoehe', ''),
		'mtom' => Request::val('mtom', ''),
		'google_map' => Request::val('google_map', ''),
		'open_street_map' => br2nl(Request::val('open_street_map', '')),
		'acg_map' => br2nl(Request::val('acg_map', '')),
		'flugbereich' => Request::fileUpload('flugbereich', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugplaetze_oe', 'flugbereich', Request::val('SelectedID'));
			},
		]),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild1', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugplaetze_oe', 'bild1', Request::val('SelectedID'));
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild2', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugplaetze_oe', 'bild2', Request::val('SelectedID'));
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild3', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('flugplaetze_oe', 'bild3', Request::val('SelectedID'));
			},
		]),
		'kontrollzone' => Request::val('kontrollzone', ''),
		'besonderheit' => Request::val('besonderheit', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];


	// hook: flugplaetze_oe_before_insert
	if(function_exists('flugplaetze_oe_before_insert')) {
		$args = [];
		if(!flugplaetze_oe_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('flugplaetze_oe', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('flugplaetze_oe', $recID, calculated_fields()['flugplaetze_oe']);

	// hook: flugplaetze_oe_after_insert
	if(function_exists('flugplaetze_oe_after_insert')) {
		$res = sql("SELECT * FROM `flugplaetze_oe` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!flugplaetze_oe_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('flugplaetze_oe', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) flugplaetze_oe_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function flugplaetze_oe_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function flugplaetze_oe_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('flugplaetze_oe', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: flugplaetze_oe_before_delete
	if(function_exists('flugplaetze_oe_before_delete')) {
		$args = [];
		if(!flugplaetze_oe_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `flugplaetze_oe` WHERE `id`='{$selected_id}'", $eo);

	// hook: flugplaetze_oe_after_delete
	if(function_exists('flugplaetze_oe_after_delete')) {
		$args = [];
		flugplaetze_oe_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='flugplaetze_oe' AND `pkValue`='{$selected_id}'", $eo);
}

function flugplaetze_oe_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('flugplaetze_oe', $selected_id, 'edit')) return false;

	$data = [
		'flugplatznummer' => Request::val('flugplatznummer', ''),
		'artikel_16' => Request::val('artikel_16', ''),
		'vereinsname' => Request::val('vereinsname', ''),
		'bundesland' => Request::val('bundesland', ''),
		'telefon' => Request::val('telefon', ''),
		'vorname' => Request::val('vorname', ''),
		'nachname' => Request::val('nachname', ''),
		'email' => Request::val('email', ''),
		'zvr' => Request::val('zvr', ''),
		'flughoehe' => Request::val('flughoehe', ''),
		'mtom' => Request::val('mtom', ''),
		'google_map' => Request::val('google_map', ''),
		'open_street_map' => br2nl(Request::val('open_street_map', '')),
		'acg_map' => br2nl(Request::val('acg_map', '')),
		'flugbereich' => Request::fileUpload('flugbereich', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugplaetze_oe', 'flugbereich', $selected_id);
			},
		]),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild1', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugplaetze_oe', 'bild1', $selected_id);
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild2', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugplaetze_oe', 'bild2', $selected_id);
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('flugplaetze_oe', 'bild3', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('flugplaetze_oe', 'bild3', $selected_id);
			},
		]),
		'kontrollzone' => Request::val('kontrollzone', ''),
		'besonderheit' => Request::val('besonderheit', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	// get existing values
	$old_data = getRecord('flugplaetze_oe', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: flugplaetze_oe_before_update
	if(function_exists('flugplaetze_oe_before_update')) {
		$args = ['old_data' => $old_data];
		if(!flugplaetze_oe_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'flugplaetze_oe', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="flugplaetze_oe_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('flugplaetze_oe', $data['selectedID'], calculated_fields()['flugplaetze_oe']);

	// hook: flugplaetze_oe_after_update
	if(function_exists('flugplaetze_oe_after_update')) {
		$res = sql("SELECT * FROM `flugplaetze_oe` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!flugplaetze_oe_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='flugplaetze_oe' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function flugplaetze_oe_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('flugplaetze_oe');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: artikel_16
	$combo_artikel_16 = new Combo;
	$combo_artikel_16->ListType = 0;
	$combo_artikel_16->MultipleSeparator = ', ';
	$combo_artikel_16->ListBoxHeight = 10;
	$combo_artikel_16->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/flugplaetze_oe.artikel_16.csv')) {
		$artikel_16_data = addslashes(implode('', @file(__DIR__ . '/hooks/flugplaetze_oe.artikel_16.csv')));
		$combo_artikel_16->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($artikel_16_data))));
		$combo_artikel_16->ListData = $combo_artikel_16->ListItem;
	} else {
		$combo_artikel_16->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Ja;;Nein"))));
		$combo_artikel_16->ListData = $combo_artikel_16->ListItem;
	}
	$combo_artikel_16->SelectName = 'artikel_16';
	// combobox: kontrollzone
	$combo_kontrollzone = new Combo;
	$combo_kontrollzone->ListType = 0;
	$combo_kontrollzone->MultipleSeparator = ', ';
	$combo_kontrollzone->ListBoxHeight = 10;
	$combo_kontrollzone->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/flugplaetze_oe.kontrollzone.csv')) {
		$kontrollzone_data = addslashes(implode('', @file(__DIR__ . '/hooks/flugplaetze_oe.kontrollzone.csv')));
		$combo_kontrollzone->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($kontrollzone_data))));
		$combo_kontrollzone->ListData = $combo_kontrollzone->ListItem;
	} else {
		$combo_kontrollzone->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Ja;;Nein"))));
		$combo_kontrollzone->ListData = $combo_kontrollzone->ListItem;
	}
	$combo_kontrollzone->SelectName = 'kontrollzone';

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='flugplaetze_oe' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='flugplaetze_oe' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `flugplaetze_oe` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'flugplaetze_oe_view.php', false);
		}
		$combo_artikel_16->SelectedData = $row['artikel_16'];
		$combo_kontrollzone->SelectedData = $row['kontrollzone'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_artikel_16->SelectedText = (isset($filterField[1]) && $filterField[1] == '3' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
		$combo_kontrollzone->SelectedText = (isset($filterField[1]) && $filterField[1] == '20' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
	}
	$combo_artikel_16->Render();
	$combo_kontrollzone->Render();

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/flugplaetze_oe_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/flugplaetze_oe_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Flugplatz in &#214;sterreich', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return flugplaetze_oe_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return flugplaetze_oe_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return flugplaetze_oe_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#flugplatznummer').replaceWith('<div class=\"form-control-static\" id=\"flugplatznummer\">' + (jQuery('#flugplatznummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#artikel_16').replaceWith('<div class=\"form-control-static\" id=\"artikel_16\">' + (jQuery('#artikel_16').val() || '') + '</div>'); jQuery('#artikel_16-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#vereinsname').replaceWith('<div class=\"form-control-static\" id=\"vereinsname\">' + (jQuery('#vereinsname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bundesland').replaceWith('<div class=\"form-control-static\" id=\"bundesland\">' + (jQuery('#bundesland').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#telefon').replaceWith('<div class=\"form-control-static\" id=\"telefon\">' + (jQuery('#telefon').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#vorname').replaceWith('<div class=\"form-control-static\" id=\"vorname\">' + (jQuery('#vorname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#nachname').replaceWith('<div class=\"form-control-static\" id=\"nachname\">' + (jQuery('#nachname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#email').replaceWith('<div class=\"form-control-static\" id=\"email\">' + (jQuery('#email').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#email, #email-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#zvr').replaceWith('<div class=\"form-control-static\" id=\"zvr\">' + (jQuery('#zvr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#flughoehe').replaceWith('<div class=\"form-control-static\" id=\"flughoehe\">' + (jQuery('#flughoehe').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#mtom').replaceWith('<div class=\"form-control-static\" id=\"mtom\">' + (jQuery('#mtom').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#google_map').replaceWith('<div class=\"form-control-static\" id=\"google_map\">' + (jQuery('#google_map').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#google_map, #google_map-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#open_street_map').replaceWith('<div class=\"form-control-static\" id=\"open_street_map\">' + (jQuery('#open_street_map').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#open_street_map, #open_street_map-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#acg_map').replaceWith('<div class=\"form-control-static\" id=\"acg_map\">' + (jQuery('#acg_map').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#acg_map, #acg_map-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#flugbereich').replaceWith('<div class=\"form-control-static\" id=\"flugbereich\">' + (jQuery('#flugbereich').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#flugbereich, #flugbereich-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#bild1').replaceWith('<div class=\"form-control-static\" id=\"bild1\">' + (jQuery('#bild1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild2').replaceWith('<div class=\"form-control-static\" id=\"bild2\">' + (jQuery('#bild2').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild3').replaceWith('<div class=\"form-control-static\" id=\"bild3\">' + (jQuery('#bild3').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kontrollzone').replaceWith('<div class=\"form-control-static\" id=\"kontrollzone\">' + (jQuery('#kontrollzone').val() || '') + '</div>'); jQuery('#kontrollzone-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#besonderheit').replaceWith('<div class=\"form-control-static\" id=\"besonderheit\">' + (jQuery('#besonderheit').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#beschreibung').replaceWith('<div class=\"form-control-static\" id=\"beschreibung\">' + (jQuery('#beschreibung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(artikel_16)%%>', $combo_artikel_16->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(artikel_16)%%>', $combo_artikel_16->SelectedData, $templateCode);
	$templateCode = str_replace('<%%COMBO(kontrollzone)%%>', $combo_kontrollzone->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(kontrollzone)%%>', $combo_kontrollzone->SelectedData, $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(flugplatznummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(artikel_16)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(vereinsname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bundesland)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(telefon)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(vorname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(nachname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(email)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(zvr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(flughoehe)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(mtom)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(google_map)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(open_street_map)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(acg_map)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(flugbereich)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="flugbereich" id="flugbereich" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2048000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['flugbereich'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(flugbereich)%%>', '<br><input type="checkbox" name="flugbereich_remove" id="flugbereich_remove" value="1"> <label for="flugbereich_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(flugbereich)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild1" id="bild1" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '<br><input type="checkbox" name="bild1_remove" id="bild1_remove" value="1"> <label for="bild1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild2)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild2" id="bild2" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild2'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '<br><input type="checkbox" name="bild2_remove" id="bild2_remove" value="1"> <label for="bild2_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild3)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild3" id="bild3" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild3'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '<br><input type="checkbox" name="bild3_remove" id="bild3_remove" value="1"> <label for="bild3_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(kontrollzone)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(besonderheit)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beschreibung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(flugplatznummer)%%>', safe_html($urow['flugplatznummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(flugplatznummer)%%>', html_attr($row['flugplatznummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugplatznummer)%%>', urlencode($urow['flugplatznummer']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(artikel_16)%%>', safe_html($urow['artikel_16']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(artikel_16)%%>', html_attr($row['artikel_16']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(artikel_16)%%>', urlencode($urow['artikel_16']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(vereinsname)%%>', safe_html($urow['vereinsname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(vereinsname)%%>', html_attr($row['vereinsname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vereinsname)%%>', urlencode($urow['vereinsname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bundesland)%%>', safe_html($urow['bundesland']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bundesland)%%>', html_attr($row['bundesland']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bundesland)%%>', urlencode($urow['bundesland']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(telefon)%%>', safe_html($urow['telefon']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(telefon)%%>', html_attr($row['telefon']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(telefon)%%>', urlencode($urow['telefon']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(vorname)%%>', safe_html($urow['vorname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(vorname)%%>', html_attr($row['vorname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vorname)%%>', urlencode($urow['vorname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(nachname)%%>', safe_html($urow['nachname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(nachname)%%>', html_attr($row['nachname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nachname)%%>', urlencode($urow['nachname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(email)%%>', safe_html($urow['email']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(email)%%>', html_attr($row['email']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(email)%%>', urlencode($urow['email']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(zvr)%%>', safe_html($urow['zvr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(zvr)%%>', html_attr($row['zvr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(zvr)%%>', urlencode($urow['zvr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(flughoehe)%%>', safe_html($urow['flughoehe']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(flughoehe)%%>', html_attr($row['flughoehe']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flughoehe)%%>', urlencode($urow['flughoehe']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(mtom)%%>', safe_html($urow['mtom']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(mtom)%%>', html_attr($row['mtom']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(mtom)%%>', urlencode($urow['mtom']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(google_map)%%>', safe_html($urow['google_map']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(google_map)%%>', html_attr($row['google_map']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(google_map)%%>', urlencode($urow['google_map']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(open_street_map)%%>', safe_html($urow['open_street_map']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(open_street_map)%%>', safe_html($urow['open_street_map'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(open_street_map)%%>', urlencode($urow['open_street_map']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(acg_map)%%>', safe_html($urow['acg_map']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(acg_map)%%>', safe_html($urow['acg_map'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(acg_map)%%>', urlencode($urow['acg_map']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(flugbereich)%%>', safe_html($urow['flugbereich']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(flugbereich)%%>', html_attr($row['flugbereich']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugbereich)%%>', urlencode($urow['flugbereich']), $templateCode);
		$row['bild1'] = ($row['bild1'] != '' ? $row['bild1'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', safe_html($urow['bild1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', html_attr($row['bild1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild1)%%>', urlencode($urow['bild1']), $templateCode);
		$row['bild2'] = ($row['bild2'] != '' ? $row['bild2'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', safe_html($urow['bild2']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', html_attr($row['bild2']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild2)%%>', urlencode($urow['bild2']), $templateCode);
		$row['bild3'] = ($row['bild3'] != '' ? $row['bild3'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', safe_html($urow['bild3']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', html_attr($row['bild3']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild3)%%>', urlencode($urow['bild3']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(kontrollzone)%%>', safe_html($urow['kontrollzone']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(kontrollzone)%%>', html_attr($row['kontrollzone']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kontrollzone)%%>', urlencode($urow['kontrollzone']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(besonderheit)%%>', safe_html($urow['besonderheit']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(besonderheit)%%>', html_attr($row['besonderheit']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(besonderheit)%%>', urlencode($urow['besonderheit']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode($urow['beschreibung']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(flugplatznummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugplatznummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(artikel_16)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(artikel_16)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(vereinsname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vereinsname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bundesland)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bundesland)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(telefon)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(telefon)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(vorname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vorname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(nachname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nachname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(email)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(email)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(zvr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(zvr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(flughoehe)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flughoehe)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(mtom)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(mtom)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(google_map)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(google_map)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(open_street_map)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(open_street_map)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(acg_map)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(acg_map)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(flugbereich)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(flugbereich)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bild1)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild2)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild3)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(kontrollzone)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kontrollzone)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(besonderheit)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(besonderheit)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beschreibung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('emailEdit')) { document.getElementById('emailEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('emailEditLink')) { document.getElementById('emailEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('google_mapEdit')) { document.getElementById('google_mapEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('google_mapEditLink')) { document.getElementById('google_mapEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('open_street_mapEdit')) { document.getElementById('open_street_mapEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('open_street_mapEditLink')) { document.getElementById('open_street_mapEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('acg_mapEdit')) { document.getElementById('acg_mapEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('acg_mapEditLink')) { document.getElementById('acg_mapEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('flugbereichEdit')) { document.getElementById('flugbereichEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('flugbereichEditLink')) { document.getElementById('flugbereichEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('flugplaetze_oe');
	if($selected_id) {
		$jdata = get_joined_record('flugplaetze_oe', $selected_id);
		if($jdata === false) $jdata = get_defaults('flugplaetze_oe');
		$rdata = $row;
	}
	$templateCode .= loadView('flugplaetze_oe-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: flugplaetze_oe_dv
	if(function_exists('flugplaetze_oe_dv')) {
		$args = [];
		flugplaetze_oe_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}