<?php

// Data functions (insert, update, delete, form) for table inventar

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function inventar_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('inventar');
	if(!$arrPerm['insert']) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'nr' => Request::val('nr', ''),
		'titel' => Request::val('titel', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('inventar', 'datei', Request::val('SelectedID'));
			},
		]),
		'anleitung' => Request::fileUpload('anleitung', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('inventar', 'anleitung', Request::val('SelectedID'));
			},
		]),
		'bild_1' => Request::fileUpload('bild_1', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_1', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('inventar', 'bild_1', Request::val('SelectedID'));
			},
		]),
		'bild_2' => Request::fileUpload('bild_2', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_2', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('inventar', 'bild_2', Request::val('SelectedID'));
			},
		]),
		'bild_3' => Request::fileUpload('bild_3', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_3', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('inventar', 'bild_3', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true, true),
	];


	// hook: inventar_before_insert
	if(function_exists('inventar_before_insert')) {
		$args = [];
		if(!inventar_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('inventar', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('inventar', $recID, calculated_fields()['inventar']);

	// hook: inventar_after_insert
	if(function_exists('inventar_after_insert')) {
		$res = sql("SELECT * FROM `inventar` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!inventar_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('inventar', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) inventar_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function inventar_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function inventar_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('inventar', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: inventar_before_delete
	if(function_exists('inventar_before_delete')) {
		$args = [];
		if(!inventar_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	// delete file stored in the 'anleitung' field
	$res = sql("SELECT `anleitung` FROM `inventar` WHERE `id`='{$selected_id}'", $eo);
	if($row = @db_fetch_row($res)) {
		if($row[0] != '') {
			@unlink(getUploadDir('') . $row[0]);
		}
	}

	// delete file stored in the 'bild_1' field
	$res = sql("SELECT `bild_1` FROM `inventar` WHERE `id`='{$selected_id}'", $eo);
	if($row = @db_fetch_row($res)) {
		if($row[0] != '') {
			@unlink(getUploadDir('') . $row[0]);
			$thumbDV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_dv.$1', $row[0]);
			$thumbTV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_tv.$1', $row[0]);
			@unlink(getUploadDir('') . $thumbTV);
			@unlink(getUploadDir('') . $thumbDV);
		}
	}

	// delete file stored in the 'bild_2' field
	$res = sql("SELECT `bild_2` FROM `inventar` WHERE `id`='{$selected_id}'", $eo);
	if($row = @db_fetch_row($res)) {
		if($row[0] != '') {
			@unlink(getUploadDir('') . $row[0]);
			$thumbDV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_dv.$1', $row[0]);
			$thumbTV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_tv.$1', $row[0]);
			@unlink(getUploadDir('') . $thumbTV);
			@unlink(getUploadDir('') . $thumbDV);
		}
	}

	// delete file stored in the 'bild_3' field
	$res = sql("SELECT `bild_3` FROM `inventar` WHERE `id`='{$selected_id}'", $eo);
	if($row = @db_fetch_row($res)) {
		if($row[0] != '') {
			@unlink(getUploadDir('') . $row[0]);
			$thumbDV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_dv.$1', $row[0]);
			$thumbTV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_tv.$1', $row[0]);
			@unlink(getUploadDir('') . $thumbTV);
			@unlink(getUploadDir('') . $thumbDV);
		}
	}

	sql("DELETE FROM `inventar` WHERE `id`='{$selected_id}'", $eo);

	// hook: inventar_after_delete
	if(function_exists('inventar_after_delete')) {
		$args = [];
		inventar_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='inventar' AND `pkValue`='{$selected_id}'", $eo);
}

function inventar_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('inventar', $selected_id, 'edit')) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'nr' => Request::val('nr', ''),
		'titel' => Request::val('titel', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('inventar', 'datei', $selected_id);
			},
		]),
		'anleitung' => Request::fileUpload('anleitung', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnSuccess' => true,
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// delete old file from server
				$oldFile = existing_value('inventar', 'anleitung', $selected_id);
				if(!$oldFile) return;

				@unlink(getUploadDir('') . $oldFile);
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('inventar', 'anleitung', $selected_id);
			},
		]),
		'bild_1' => Request::fileUpload('bild_1', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_1', 'dv'));
			},
			'removeOnSuccess' => true,
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// delete old file from server
				$oldFile = existing_value('inventar', 'bild_1', $selected_id);
				if(!$oldFile) return;

				@unlink(getUploadDir('') . $oldFile);

				// delete thumbnails
				preg_match('/^[a-z0-9_]+\.(jpg|jpeg|gif|png|webp)$/i', $oldFile, $m);
				$thumbDV = str_replace(".{$m[1]}ffffgggg", "_dv.{$m[1]}", $oldFile . 'ffffgggg');
				$thumbTV = str_replace(".{$m[1]}ffffgggg", "_tv.{$m[1]}", $oldFile . 'ffffgggg');
				@unlink(getUploadDir('') . $thumbTV);
				@unlink(getUploadDir('') . $thumbDV);
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('inventar', 'bild_1', $selected_id);
			},
		]),
		'bild_2' => Request::fileUpload('bild_2', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_2', 'dv'));
			},
			'removeOnSuccess' => true,
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// delete old file from server
				$oldFile = existing_value('inventar', 'bild_2', $selected_id);
				if(!$oldFile) return;

				@unlink(getUploadDir('') . $oldFile);

				// delete thumbnails
				preg_match('/^[a-z0-9_]+\.(jpg|jpeg|gif|png|webp)$/i', $oldFile, $m);
				$thumbDV = str_replace(".{$m[1]}ffffgggg", "_dv.{$m[1]}", $oldFile . 'ffffgggg');
				$thumbTV = str_replace(".{$m[1]}ffffgggg", "_tv.{$m[1]}", $oldFile . 'ffffgggg');
				@unlink(getUploadDir('') . $thumbTV);
				@unlink(getUploadDir('') . $thumbDV);
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('inventar', 'bild_2', $selected_id);
			},
		]),
		'bild_3' => Request::fileUpload('bild_3', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('inventar', 'bild_3', 'dv'));
			},
			'removeOnSuccess' => true,
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// delete old file from server
				$oldFile = existing_value('inventar', 'bild_3', $selected_id);
				if(!$oldFile) return;

				@unlink(getUploadDir('') . $oldFile);

				// delete thumbnails
				preg_match('/^[a-z0-9_]+\.(jpg|jpeg|gif|png|webp)$/i', $oldFile, $m);
				$thumbDV = str_replace(".{$m[1]}ffffgggg", "_dv.{$m[1]}", $oldFile . 'ffffgggg');
				$thumbTV = str_replace(".{$m[1]}ffffgggg", "_tv.{$m[1]}", $oldFile . 'ffffgggg');
				@unlink(getUploadDir('') . $thumbTV);
				@unlink(getUploadDir('') . $thumbDV);
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('inventar', 'bild_3', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false, true),
	];

	// get existing values
	$old_data = getRecord('inventar', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: inventar_before_update
	if(function_exists('inventar_before_update')) {
		$args = ['old_data' => $old_data];
		if(!inventar_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'inventar', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="inventar_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('inventar', $data['selectedID'], calculated_fields()['inventar']);

	// hook: inventar_after_update
	if(function_exists('inventar_after_update')) {
		$res = sql("SELECT * FROM `inventar` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!inventar_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='inventar' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function inventar_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = false;

	// mm: get table permissions
	$arrPerm = getTablePermissions('inventar');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='inventar' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='inventar' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `inventar` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'inventar_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
	}

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/inventar_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/inventar_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Inventar', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert) {
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return inventar_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return inventar_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return inventar_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#datum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"datum\">' + (jQuery('#datum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#nr').replaceWith('<div class=\"form-control-static\" id=\"nr\">' + (jQuery('#nr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#titel').replaceWith('<div class=\"form-control-static\" id=\"titel\">' + (jQuery('#titel').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#beschreibung').replaceWith('<div class=\"form-control-static\" id=\"beschreibung\">' + (jQuery('#beschreibung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei').replaceWith('<div class=\"form-control-static\" id=\"datei\">' + (jQuery('#datei').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei, #datei-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#anleitung').replaceWith('<div class=\"form-control-static\" id=\"anleitung\">' + (jQuery('#anleitung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anleitung, #anleitung-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#bild_1').replaceWith('<div class=\"form-control-static\" id=\"bild_1\">' + (jQuery('#bild_1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild_2').replaceWith('<div class=\"form-control-static\" id=\"bild_2\">' + (jQuery('#bild_2').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild_3').replaceWith('<div class=\"form-control-static\" id=\"bild_3\">' + (jQuery('#bild_3').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif($AllowInsert) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#datum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(nr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(titel)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beschreibung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datei)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei" id="datei" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2560000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '<br><input type="checkbox" name="datei_remove" id="datei_remove" value="1"> <label for="datei_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(anleitung)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="anleitung" id="anleitung" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2560000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['anleitung'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(anleitung)%%>', '<br><input type="checkbox" name="anleitung_remove" id="anleitung_remove" value="1"> <label for="anleitung_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(anleitung)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild_1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild_1" id="bild_1" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2560000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild_1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild_1)%%>', '<br><input type="checkbox" name="bild_1_remove" id="bild_1_remove" value="1"> <label for="bild_1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild_1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild_2)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild_2" id="bild_2" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2560000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild_2'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild_2)%%>', '<br><input type="checkbox" name="bild_2_remove" id="bild_2_remove" value="1"> <label for="bild_2_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild_2)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild_3)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild_3" id="bild_3" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2560000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild_3'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild_3)%%>', '<br><input type="checkbox" name="bild_3_remove" id="bild_3_remove" value="1"> <label for="bild_3_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild_3)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', app_datetime($row['datum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(app_datetime($urow['datum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(nr)%%>', safe_html($urow['nr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(nr)%%>', html_attr($row['nr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nr)%%>', urlencode($urow['nr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(titel)%%>', safe_html($urow['titel']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(titel)%%>', html_attr($row['titel']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel)%%>', urlencode($urow['titel']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode($urow['beschreibung']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', safe_html($urow['datei']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', html_attr($row['datei']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode($urow['datei']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(anleitung)%%>', safe_html($urow['anleitung']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(anleitung)%%>', html_attr($row['anleitung']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anleitung)%%>', urlencode($urow['anleitung']), $templateCode);
		$row['bild_1'] = ($row['bild_1'] != '' ? $row['bild_1'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild_1)%%>', safe_html($urow['bild_1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild_1)%%>', html_attr($row['bild_1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild_1)%%>', urlencode($urow['bild_1']), $templateCode);
		$row['bild_2'] = ($row['bild_2'] != '' ? $row['bild_2'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild_2)%%>', safe_html($urow['bild_2']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild_2)%%>', html_attr($row['bild_2']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild_2)%%>', urlencode($urow['bild_2']), $templateCode);
		$row['bild_3'] = ($row['bild_3'] != '' ? $row['bild_3'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild_3)%%>', safe_html($urow['bild_3']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild_3)%%>', html_attr($row['bild_3']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild_3)%%>', urlencode($urow['bild_3']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', app_datetime($row['erfasst'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode(app_datetime($urow['erfasst'], 'dt')), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', app_datetime($row['geaendert'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode(app_datetime($urow['geaendert'], 'dt')), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(nr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(titel)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beschreibung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datei)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anleitung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anleitung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bild_1)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild_2)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild_3)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('dateiEdit')) { document.getElementById('dateiEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('dateiEditLink')) { document.getElementById('dateiEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('anleitungEdit')) { document.getElementById('anleitungEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('anleitungEditLink')) { document.getElementById('anleitungEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('inventar');
	if($selected_id) {
		$jdata = get_joined_record('inventar', $selected_id);
		if($jdata === false) $jdata = get_defaults('inventar');
		$rdata = $row;
	}
	$templateCode .= loadView('inventar-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: inventar_dv
	if(function_exists('inventar_dv')) {
		$args = [];
		inventar_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}