<?php

// Data functions (insert, update, delete, form) for table mitgliederverwaltung

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function mitgliederverwaltung_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('mitgliederverwaltung');
	if(!$arrPerm['insert']) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'nr' => Request::val('nr', ''),
		'anrede' => Request::val('anrede', ''),
		'titel_vor' => Request::val('titel_vor', ''),
		'titel_nach' => Request::val('titel_nach', ''),
		'vorname' => Request::val('vorname', ''),
		'nachname' => Request::val('nachname', ''),
		'geburtsdatum' => mysql_datetime(Request::val('geburtsdatum', '')),
		'beitrittsjahr' => Request::val('beitrittsjahr', ''),
		'oeaec_nr' => Request::val('oeaec_nr', ''),
		'status' => Request::val('status', ''),
		'strasse' => Request::val('strasse', ''),
		'nummer' => Request::val('nummer', ''),
		'plz' => Request::val('plz', ''),
		'ort' => Request::val('ort', ''),
		'telefon' => Request::val('telefon', ''),
		'mobiltelefon' => Request::val('mobiltelefon', ''),
		'email' => Request::val('email', ''),
		'funktionen' => Request::val('funktionen', ''),
		'registriernummer' => Request::val('registriernummer', ''),
		'reg_gueltig' => mysql_datetime(Request::val('reg_gueltig', '')),
		'kompetenznachweis' => Request::val('kompetenznachweis', ''),
		'kom_gueltig' => mysql_datetime(Request::val('kom_gueltig', '')),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'pruefungen' => Request::val('pruefungen', ''),
		'bild' => Request::fileUpload('bild', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('mitgliederverwaltung', 'bild', 'tv'));
				createThumbnail($name, getThumbnailSpecs('mitgliederverwaltung', 'bild', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('mitgliederverwaltung', 'bild', Request::val('SelectedID'));
			},
		]),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('mitgliederverwaltung', 'datei', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true, true),
	];


	// hook: mitgliederverwaltung_before_insert
	if(function_exists('mitgliederverwaltung_before_insert')) {
		$args = [];
		if(!mitgliederverwaltung_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('mitgliederverwaltung', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('mitgliederverwaltung', $recID, calculated_fields()['mitgliederverwaltung']);

	// hook: mitgliederverwaltung_after_insert
	if(function_exists('mitgliederverwaltung_after_insert')) {
		$res = sql("SELECT * FROM `mitgliederverwaltung` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!mitgliederverwaltung_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('mitgliederverwaltung', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) mitgliederverwaltung_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function mitgliederverwaltung_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function mitgliederverwaltung_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('mitgliederverwaltung', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: mitgliederverwaltung_before_delete
	if(function_exists('mitgliederverwaltung_before_delete')) {
		$args = [];
		if(!mitgliederverwaltung_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	// delete file stored in the 'bild' field
	$res = sql("SELECT `bild` FROM `mitgliederverwaltung` WHERE `id`='{$selected_id}'", $eo);
	if($row = @db_fetch_row($res)) {
		if($row[0] != '') {
			@unlink(getUploadDir('') . $row[0]);
			$thumbDV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_dv.$1', $row[0]);
			$thumbTV = preg_replace('/\.(jpg|jpeg|gif|png|webp)$/i', '_tv.$1', $row[0]);
			@unlink(getUploadDir('') . $thumbTV);
			@unlink(getUploadDir('') . $thumbDV);
		}
	}

	sql("DELETE FROM `mitgliederverwaltung` WHERE `id`='{$selected_id}'", $eo);

	// hook: mitgliederverwaltung_after_delete
	if(function_exists('mitgliederverwaltung_after_delete')) {
		$args = [];
		mitgliederverwaltung_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='mitgliederverwaltung' AND `pkValue`='{$selected_id}'", $eo);
}

function mitgliederverwaltung_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('mitgliederverwaltung', $selected_id, 'edit')) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'nr' => Request::val('nr', ''),
		'anrede' => Request::val('anrede', ''),
		'titel_vor' => Request::val('titel_vor', ''),
		'titel_nach' => Request::val('titel_nach', ''),
		'vorname' => Request::val('vorname', ''),
		'nachname' => Request::val('nachname', ''),
		'geburtsdatum' => mysql_datetime(Request::val('geburtsdatum', '')),
		'beitrittsjahr' => Request::val('beitrittsjahr', ''),
		'oeaec_nr' => Request::val('oeaec_nr', ''),
		'status' => Request::val('status', ''),
		'strasse' => Request::val('strasse', ''),
		'nummer' => Request::val('nummer', ''),
		'plz' => Request::val('plz', ''),
		'ort' => Request::val('ort', ''),
		'telefon' => Request::val('telefon', ''),
		'mobiltelefon' => Request::val('mobiltelefon', ''),
		'email' => Request::val('email', ''),
		'funktionen' => Request::val('funktionen', ''),
		'registriernummer' => Request::val('registriernummer', ''),
		'reg_gueltig' => mysql_datetime(Request::val('reg_gueltig', '')),
		'kompetenznachweis' => Request::val('kompetenznachweis', ''),
		'kom_gueltig' => mysql_datetime(Request::val('kom_gueltig', '')),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'pruefungen' => Request::val('pruefungen', ''),
		'bild' => Request::fileUpload('bild', [
			'maxSize' => 2560000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('mitgliederverwaltung', 'bild', 'tv'));
				createThumbnail($name, getThumbnailSpecs('mitgliederverwaltung', 'bild', 'dv'));
			},
			'removeOnSuccess' => true,
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// delete old file from server
				$oldFile = existing_value('mitgliederverwaltung', 'bild', $selected_id);
				if(!$oldFile) return;

				@unlink(getUploadDir('') . $oldFile);

				// delete thumbnails
				preg_match('/^[a-z0-9_]+\.(jpg|jpeg|gif|png|webp)$/i', $oldFile, $m);
				$thumbDV = str_replace(".{$m[1]}ffffgggg", "_dv.{$m[1]}", $oldFile . 'ffffgggg');
				$thumbTV = str_replace(".{$m[1]}ffffgggg", "_tv.{$m[1]}", $oldFile . 'ffffgggg');
				@unlink(getUploadDir('') . $thumbTV);
				@unlink(getUploadDir('') . $thumbDV);
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('mitgliederverwaltung', 'bild', $selected_id);
			},
		]),
		'datei' => Request::fileUpload('datei', [
			'maxSize' => 2560000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('mitgliederverwaltung', 'datei', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false, true),
	];

	// get existing values
	$old_data = getRecord('mitgliederverwaltung', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: mitgliederverwaltung_before_update
	if(function_exists('mitgliederverwaltung_before_update')) {
		$args = ['old_data' => $old_data];
		if(!mitgliederverwaltung_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'mitgliederverwaltung', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="mitgliederverwaltung_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('mitgliederverwaltung', $data['selectedID'], calculated_fields()['mitgliederverwaltung']);

	// hook: mitgliederverwaltung_after_update
	if(function_exists('mitgliederverwaltung_after_update')) {
		$res = sql("SELECT * FROM `mitgliederverwaltung` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!mitgliederverwaltung_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='mitgliederverwaltung' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function mitgliederverwaltung_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = false;

	// mm: get table permissions
	$arrPerm = getTablePermissions('mitgliederverwaltung');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='mitgliederverwaltung' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='mitgliederverwaltung' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `mitgliederverwaltung` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'mitgliederverwaltung_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
	}

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/mitgliederverwaltung_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/mitgliederverwaltung_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Mitglied', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert) {
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return mitgliederverwaltung_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return mitgliederverwaltung_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return mitgliederverwaltung_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#datum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"datum\">' + (jQuery('#datum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#nr').replaceWith('<div class=\"form-control-static\" id=\"nr\">' + (jQuery('#nr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anrede').replaceWith('<div class=\"form-control-static\" id=\"anrede\">' + (jQuery('#anrede').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#titel_vor').replaceWith('<div class=\"form-control-static\" id=\"titel_vor\">' + (jQuery('#titel_vor').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#titel_nach').replaceWith('<div class=\"form-control-static\" id=\"titel_nach\">' + (jQuery('#titel_nach').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#vorname').replaceWith('<div class=\"form-control-static\" id=\"vorname\">' + (jQuery('#vorname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#nachname').replaceWith('<div class=\"form-control-static\" id=\"nachname\">' + (jQuery('#nachname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#geburtsdatum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"geburtsdatum\">' + (jQuery('#geburtsdatum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#beitrittsjahr').replaceWith('<div class=\"form-control-static\" id=\"beitrittsjahr\">' + (jQuery('#beitrittsjahr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#oeaec_nr').replaceWith('<div class=\"form-control-static\" id=\"oeaec_nr\">' + (jQuery('#oeaec_nr').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#status').replaceWith('<div class=\"form-control-static\" id=\"status\">' + (jQuery('#status').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#strasse').replaceWith('<div class=\"form-control-static\" id=\"strasse\">' + (jQuery('#strasse').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#nummer').replaceWith('<div class=\"form-control-static\" id=\"nummer\">' + (jQuery('#nummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#plz').replaceWith('<div class=\"form-control-static\" id=\"plz\">' + (jQuery('#plz').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#ort').replaceWith('<div class=\"form-control-static\" id=\"ort\">' + (jQuery('#ort').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#telefon').replaceWith('<div class=\"form-control-static\" id=\"telefon\">' + (jQuery('#telefon').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#mobiltelefon').replaceWith('<div class=\"form-control-static\" id=\"mobiltelefon\">' + (jQuery('#mobiltelefon').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#email').replaceWith('<div class=\"form-control-static\" id=\"email\">' + (jQuery('#email').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#email, #email-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#funktionen').replaceWith('<div class=\"form-control-static\" id=\"funktionen\">' + (jQuery('#funktionen').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#registriernummer').replaceWith('<div class=\"form-control-static\" id=\"registriernummer\">' + (jQuery('#registriernummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#reg_gueltig').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"reg_gueltig\">' + (jQuery('#reg_gueltig').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kompetenznachweis').replaceWith('<div class=\"form-control-static\" id=\"kompetenznachweis\">' + (jQuery('#kompetenznachweis').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kom_gueltig').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"kom_gueltig\">' + (jQuery('#kom_gueltig').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#beschreibung').replaceWith('<div class=\"form-control-static\" id=\"beschreibung\">' + (jQuery('#beschreibung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#pruefungen').replaceWith('<div class=\"form-control-static\" id=\"pruefungen\">' + (jQuery('#pruefungen').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild').replaceWith('<div class=\"form-control-static\" id=\"bild\">' + (jQuery('#bild').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei').replaceWith('<div class=\"form-control-static\" id=\"datei\">' + (jQuery('#datei').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datei, #datei-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif($AllowInsert) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#datum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#geburtsdatum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#reg_gueltig').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#kom_gueltig').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(nr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(anrede)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(titel_vor)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(titel_nach)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(vorname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(nachname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geburtsdatum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beitrittsjahr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(oeaec_nr)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(status)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(strasse)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(nummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(plz)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(ort)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(telefon)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(mobiltelefon)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(email)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(funktionen)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(registriernummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(reg_gueltig)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kompetenznachweis)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kom_gueltig)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beschreibung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(pruefungen)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bild)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild" id="bild" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2560000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild)%%>', '<br><input type="checkbox" name="bild_remove" id="bild_remove" value="1"> <label for="bild_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(datei)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datei" id="datei" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2560000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datei'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '<br><input type="checkbox" name="datei_remove" id="datei_remove" value="1"> <label for="datei_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datei)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', app_datetime($row['datum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(app_datetime($urow['datum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(nr)%%>', safe_html($urow['nr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(nr)%%>', html_attr($row['nr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nr)%%>', urlencode($urow['nr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(anrede)%%>', safe_html($urow['anrede']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(anrede)%%>', html_attr($row['anrede']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anrede)%%>', urlencode($urow['anrede']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(titel_vor)%%>', safe_html($urow['titel_vor']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(titel_vor)%%>', html_attr($row['titel_vor']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel_vor)%%>', urlencode($urow['titel_vor']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(titel_nach)%%>', safe_html($urow['titel_nach']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(titel_nach)%%>', html_attr($row['titel_nach']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel_nach)%%>', urlencode($urow['titel_nach']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(vorname)%%>', safe_html($urow['vorname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(vorname)%%>', html_attr($row['vorname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vorname)%%>', urlencode($urow['vorname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(nachname)%%>', safe_html($urow['nachname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(nachname)%%>', html_attr($row['nachname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nachname)%%>', urlencode($urow['nachname']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geburtsdatum)%%>', app_datetime($row['geburtsdatum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geburtsdatum)%%>', urlencode(app_datetime($urow['geburtsdatum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(beitrittsjahr)%%>', safe_html($urow['beitrittsjahr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(beitrittsjahr)%%>', html_attr($row['beitrittsjahr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beitrittsjahr)%%>', urlencode($urow['beitrittsjahr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(oeaec_nr)%%>', safe_html($urow['oeaec_nr']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(oeaec_nr)%%>', html_attr($row['oeaec_nr']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(oeaec_nr)%%>', urlencode($urow['oeaec_nr']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(status)%%>', safe_html($urow['status']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(status)%%>', html_attr($row['status']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(status)%%>', urlencode($urow['status']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(strasse)%%>', safe_html($urow['strasse']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(strasse)%%>', html_attr($row['strasse']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(strasse)%%>', urlencode($urow['strasse']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(nummer)%%>', safe_html($urow['nummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(nummer)%%>', html_attr($row['nummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nummer)%%>', urlencode($urow['nummer']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(plz)%%>', safe_html($urow['plz']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(plz)%%>', html_attr($row['plz']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(plz)%%>', urlencode($urow['plz']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(ort)%%>', safe_html($urow['ort']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(ort)%%>', html_attr($row['ort']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ort)%%>', urlencode($urow['ort']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(telefon)%%>', safe_html($urow['telefon']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(telefon)%%>', html_attr($row['telefon']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(telefon)%%>', urlencode($urow['telefon']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(mobiltelefon)%%>', safe_html($urow['mobiltelefon']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(mobiltelefon)%%>', html_attr($row['mobiltelefon']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(mobiltelefon)%%>', urlencode($urow['mobiltelefon']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(email)%%>', safe_html($urow['email']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(email)%%>', html_attr($row['email']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(email)%%>', urlencode($urow['email']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(funktionen)%%>', safe_html($urow['funktionen']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(funktionen)%%>', html_attr($row['funktionen']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(funktionen)%%>', urlencode($urow['funktionen']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(registriernummer)%%>', safe_html($urow['registriernummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(registriernummer)%%>', html_attr($row['registriernummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(registriernummer)%%>', urlencode($urow['registriernummer']), $templateCode);
		$templateCode = str_replace('<%%VALUE(reg_gueltig)%%>', app_datetime($row['reg_gueltig'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(reg_gueltig)%%>', urlencode(app_datetime($urow['reg_gueltig'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(kompetenznachweis)%%>', safe_html($urow['kompetenznachweis']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(kompetenznachweis)%%>', html_attr($row['kompetenznachweis']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kompetenznachweis)%%>', urlencode($urow['kompetenznachweis']), $templateCode);
		$templateCode = str_replace('<%%VALUE(kom_gueltig)%%>', app_datetime($row['kom_gueltig'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kom_gueltig)%%>', urlencode(app_datetime($urow['kom_gueltig'], 'dt')), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode($urow['beschreibung']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(pruefungen)%%>', safe_html($urow['pruefungen']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(pruefungen)%%>', html_attr($row['pruefungen']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(pruefungen)%%>', urlencode($urow['pruefungen']), $templateCode);
		$row['bild'] = ($row['bild'] != '' ? $row['bild'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild)%%>', safe_html($urow['bild']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild)%%>', html_attr($row['bild']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild)%%>', urlencode($urow['bild']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', safe_html($urow['datei']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datei)%%>', html_attr($row['datei']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode($urow['datei']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', app_datetime($row['erfasst'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode(app_datetime($urow['erfasst'], 'dt')), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', app_datetime($row['geaendert'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode(app_datetime($urow['geaendert'], 'dt')), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(nr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anrede)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anrede)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(titel_vor)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel_vor)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(titel_nach)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(titel_nach)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(vorname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(vorname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(nachname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nachname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(geburtsdatum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geburtsdatum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beitrittsjahr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beitrittsjahr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(oeaec_nr)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(oeaec_nr)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(status)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(status)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(strasse)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(strasse)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(nummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(nummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(plz)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(plz)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(ort)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(ort)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(telefon)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(telefon)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(mobiltelefon)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(mobiltelefon)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(email)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(email)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(funktionen)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(funktionen)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(registriernummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(registriernummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(reg_gueltig)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(reg_gueltig)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kompetenznachweis)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kompetenznachweis)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kom_gueltig)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kom_gueltig)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beschreibung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(pruefungen)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(pruefungen)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bild)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(datei)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datei)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('emailEdit')) { document.getElementById('emailEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('emailEditLink')) { document.getElementById('emailEditLink').style.display='none'; }";
			$templateCode.="\n\tif(document.getElementById('dateiEdit')) { document.getElementById('dateiEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('dateiEditLink')) { document.getElementById('dateiEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('mitgliederverwaltung');
	if($selected_id) {
		$jdata = get_joined_record('mitgliederverwaltung', $selected_id);
		if($jdata === false) $jdata = get_defaults('mitgliederverwaltung');
		$rdata = $row;
	}
	$templateCode .= loadView('mitgliederverwaltung-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: mitgliederverwaltung_dv
	if(function_exists('mitgliederverwaltung_dv')) {
		$args = [];
		mitgliederverwaltung_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}