<?php

// Data functions (insert, update, delete, form) for table modellbetriebskartei

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function modellbetriebskartei_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('modellbetriebskartei');
	if(!$arrPerm['insert']) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'modellname' => Request::lookup('modellname', ''),
		'betriebszeit_min' => Request::val('betriebszeit_min', ''),
		'defekte' => br2nl(Request::val('defekte', '')),
		'anmerkung' => br2nl(Request::val('anmerkung', '')),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];


	// hook: modellbetriebskartei_before_insert
	if(function_exists('modellbetriebskartei_before_insert')) {
		$args = [];
		if(!modellbetriebskartei_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('modellbetriebskartei', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('modellbetriebskartei', $recID, calculated_fields()['modellbetriebskartei']);

	// hook: modellbetriebskartei_after_insert
	if(function_exists('modellbetriebskartei_after_insert')) {
		$res = sql("SELECT * FROM `modellbetriebskartei` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!modellbetriebskartei_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('modellbetriebskartei', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) modellbetriebskartei_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function modellbetriebskartei_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function modellbetriebskartei_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('modellbetriebskartei', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: modellbetriebskartei_before_delete
	if(function_exists('modellbetriebskartei_before_delete')) {
		$args = [];
		if(!modellbetriebskartei_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `modellbetriebskartei` WHERE `id`='{$selected_id}'", $eo);

	// hook: modellbetriebskartei_after_delete
	if(function_exists('modellbetriebskartei_after_delete')) {
		$args = [];
		modellbetriebskartei_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='modellbetriebskartei' AND `pkValue`='{$selected_id}'", $eo);
}

function modellbetriebskartei_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('modellbetriebskartei', $selected_id, 'edit')) return false;

	$data = [
		'datum' => mysql_datetime(Request::val('datum', '')),
		'modellname' => Request::lookup('modellname', ''),
		'betriebszeit_min' => Request::val('betriebszeit_min', ''),
		'defekte' => br2nl(Request::val('defekte', '')),
		'anmerkung' => br2nl(Request::val('anmerkung', '')),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	// get existing values
	$old_data = getRecord('modellbetriebskartei', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: modellbetriebskartei_before_update
	if(function_exists('modellbetriebskartei_before_update')) {
		$args = ['old_data' => $old_data];
		if(!modellbetriebskartei_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'modellbetriebskartei', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="modellbetriebskartei_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('modellbetriebskartei', $data['selectedID'], calculated_fields()['modellbetriebskartei']);

	// hook: modellbetriebskartei_after_update
	if(function_exists('modellbetriebskartei_after_update')) {
		$res = sql("SELECT * FROM `modellbetriebskartei` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!modellbetriebskartei_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='modellbetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function modellbetriebskartei_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('modellbetriebskartei');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}

	$filterer_modellname = Request::val('filterer_modellname');

	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: modellname
	$combo_modellname = new DataCombo;

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='modellbetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='modellbetriebskartei' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `modellbetriebskartei` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'modellbetriebskartei_view.php', false);
		}
		$combo_modellname->SelectedData = $row['modellname'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_modellname->SelectedData = $filterer_modellname;
	}
	$combo_modellname->HTML = '<span id="modellname-container' . $rnd1 . '"></span><input type="hidden" name="modellname" id="modellname' . $rnd1 . '" value="' . html_attr($combo_modellname->SelectedData) . '">';
	$combo_modellname->MatchText = '<span id="modellname-container-readonly' . $rnd1 . '"></span><input type="hidden" name="modellname" id="modellname' . $rnd1 . '" value="' . html_attr($combo_modellname->SelectedData) . '">';

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_modellname__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['modellname'] : htmlspecialchars($filterer_modellname, ENT_QUOTES)); ?>"};

		jQuery(function() {
			setTimeout(function() {
				if(typeof(modellname_reload__RAND__) == 'function') modellname_reload__RAND__();
			}, 50); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function modellname_reload__RAND__() {
		<?php if(($AllowUpdate || ($arrPerm['insert'] && !$selected_id)) && !$dvprint) { ?>

			$j("#modellname-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c) {
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_modellname__RAND__.value, t: 'modellbetriebskartei', f: 'modellname' },
						success: function(resp) {
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="modellname"]').val(resp.results[0].id);
							$j('[id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }


							if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
						}
					});
				},
				width: '100%',
				formatNoMatches: function(term) { return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 5,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page) { return { s: term, p: page, t: 'modellbetriebskartei', f: 'modellname' }; },
					results: function(resp, page) { return resp; }
				},
				escapeMarkup: function(str) { return str; }
			}).on('change', function(e) {
				AppGini.current_modellname__RAND__.value = e.added.id;
				AppGini.current_modellname__RAND__.text = e.added.text;
				$j('[name="modellname"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }


				if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
			});

			if(!$j("#modellname-container__RAND__").length) {
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_modellname__RAND__.value, t: 'modellbetriebskartei', f: 'modellname' },
					success: function(resp) {
						$j('[name="modellname"]').val(resp.results[0].id);
						$j('[id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }

						if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
					}
				});
			}

		<?php } else { ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_modellname__RAND__.value, t: 'modellbetriebskartei', f: 'modellname' },
				success: function(resp) {
					$j('[id=modellname-container__RAND__], [id=modellname-container-readonly__RAND__]').html('<span class="match-text" id="modellname-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>') { $j('.btn[id=modelle_view_parent]').hide(); } else { $j('.btn[id=modelle_view_parent]').show(); }

					if(typeof(modellname_update_autofills__RAND__) == 'function') modellname_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_clean());


	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/modellbetriebskartei_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/modellbetriebskartei_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Modell Betriebsaufzeichnung', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return modellbetriebskartei_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return modellbetriebskartei_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return modellbetriebskartei_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#datum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"datum\">' + (jQuery('#datum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#modellname').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#modellname_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#betriebszeit_min').replaceWith('<div class=\"form-control-static\" id=\"betriebszeit_min\">' + (jQuery('#betriebszeit_min').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#defekte').replaceWith('<div class=\"form-control-static\" id=\"defekte\">' + (jQuery('#defekte').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#anmerkung').replaceWith('<div class=\"form-control-static\" id=\"anmerkung\">' + (jQuery('#anmerkung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#datum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(modellname)%%>', $combo_modellname->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(modellname)%%>', $combo_modellname->MatchText, $templateCode);
	$templateCode = str_replace('<%%URLCOMBOTEXT(modellname)%%>', urlencode($combo_modellname->MatchText), $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = ['modellname' => ['modelle', 'Modellname'], ];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(datum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(modellname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(betriebszeit_min)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(betriebszeit_std)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(defekte)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(anmerkung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', app_datetime($row['datum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(app_datetime($urow['datum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', safe_html($urow['modellname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', html_attr($row['modellname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode($urow['modellname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(betriebszeit_min)%%>', safe_html($urow['betriebszeit_min']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(betriebszeit_min)%%>', html_attr($row['betriebszeit_min']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(betriebszeit_min)%%>', urlencode($urow['betriebszeit_min']), $templateCode);
		$templateCode = str_replace('<%%VALUE(betriebszeit_std)%%>', safe_html($urow['betriebszeit_std']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(betriebszeit_std)%%>', urlencode($urow['betriebszeit_std']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(defekte)%%>', safe_html($urow['defekte']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(defekte)%%>', safe_html($urow['defekte'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(defekte)%%>', urlencode($urow['defekte']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(anmerkung)%%>', safe_html($urow['anmerkung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(anmerkung)%%>', safe_html($urow['anmerkung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(anmerkung)%%>', urlencode($urow['anmerkung']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(datum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(modellname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(betriebszeit_min)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(betriebszeit_min)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(betriebszeit_std)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(betriebszeit_std)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(defekte)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(defekte)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(anmerkung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(anmerkung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('modellbetriebskartei');
	if($selected_id) {
		$jdata = get_joined_record('modellbetriebskartei', $selected_id);
		if($jdata === false) $jdata = get_defaults('modellbetriebskartei');
		$rdata = $row;
	}
	$templateCode .= loadView('modellbetriebskartei-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: modellbetriebskartei_dv
	if(function_exists('modellbetriebskartei_dv')) {
		$args = [];
		modellbetriebskartei_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}