<?php

// Data functions (insert, update, delete, form) for table modelle

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function modelle_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('modelle');
	if(!$arrPerm['insert']) return false;

	$data = [
		'inventarnummer' => Request::val('inventarnummer', ''),
		'modellname' => Request::val('modellname', ''),
		'hersteller' => Request::val('hersteller', ''),
		'modelltyp' => Request::val('modelltyp', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'kaufdatum' => mysql_datetime(Request::val('kaufdatum', '')),
		'erstflugdatum' => mysql_datetime(Request::val('erstflugdatum', '')),
		'gewicht' => Request::val('gewicht', ''),
		'kaufpreis' => Request::val('kaufpreis', ''),
		'technische_ausstattung' => br2nl(Request::val('technische_ausstattung', '')),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild1', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('modelle', 'bild1', Request::val('SelectedID'));
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild2', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('modelle', 'bild2', Request::val('SelectedID'));
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild3', 'dv'));
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('modelle', 'bild3', Request::val('SelectedID'));
			},
		]),
		'datenblatt' => Request::fileUpload('datenblatt', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('modelle', 'datenblatt', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
	];

	if($data['modelltyp'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Modelltyp': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}

	// hook: modelle_before_insert
	if(function_exists('modelle_before_insert')) {
		$args = [];
		if(!modelle_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('modelle', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('modelle', $recID, calculated_fields()['modelle']);

	// hook: modelle_after_insert
	if(function_exists('modelle_after_insert')) {
		$res = sql("SELECT * FROM `modelle` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!modelle_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('modelle', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) modelle_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function modelle_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function modelle_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('modelle', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: modelle_before_delete
	if(function_exists('modelle_before_delete')) {
		$args = [];
		if(!modelle_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	// child table: checklisten
	$res = sql("SELECT `id` FROM `modelle` WHERE `id`='{$selected_id}'", $eo);
	$id = db_fetch_row($res);
	$rires = sql("SELECT COUNT(1) FROM `checklisten` WHERE `modellname`='" . makeSafe($id[0]) . "'", $eo);
	$rirow = db_fetch_row($rires);
	if($rirow[0] && !$AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation["couldn't delete"];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'checklisten', $RetMsg);
		return $RetMsg;
	} elseif($rirow[0] && $AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation['confirm delete'];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'checklisten', $RetMsg);
		$RetMsg = str_replace('<Delete>', '<input type="button" class="btn btn-danger" value="' . html_attr($Translation['yes']) . '" onClick="window.location = \'modelle_view.php?SelectedID=' . urlencode($selected_id) . '&delete_x=1&confirmed=1&csrf_token=' . urlencode(csrf_token(false, true)) . '\';">', $RetMsg);
		$RetMsg = str_replace('<Cancel>', '<input type="button" class="btn btn-success" value="' . html_attr($Translation[ 'no']) . '" onClick="window.location = \'modelle_view.php?SelectedID=' . urlencode($selected_id) . '\';">', $RetMsg);
		return $RetMsg;
	}

	// child table: modellbetriebskartei
	$res = sql("SELECT `id` FROM `modelle` WHERE `id`='{$selected_id}'", $eo);
	$id = db_fetch_row($res);
	$rires = sql("SELECT COUNT(1) FROM `modellbetriebskartei` WHERE `modellname`='" . makeSafe($id[0]) . "'", $eo);
	$rirow = db_fetch_row($rires);
	if($rirow[0] && !$AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation["couldn't delete"];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'modellbetriebskartei', $RetMsg);
		return $RetMsg;
	} elseif($rirow[0] && $AllowDeleteOfParents && !$skipChecks) {
		$RetMsg = $Translation['confirm delete'];
		$RetMsg = str_replace('<RelatedRecords>', $rirow[0], $RetMsg);
		$RetMsg = str_replace('<TableName>', 'modellbetriebskartei', $RetMsg);
		$RetMsg = str_replace('<Delete>', '<input type="button" class="btn btn-danger" value="' . html_attr($Translation['yes']) . '" onClick="window.location = \'modelle_view.php?SelectedID=' . urlencode($selected_id) . '&delete_x=1&confirmed=1&csrf_token=' . urlencode(csrf_token(false, true)) . '\';">', $RetMsg);
		$RetMsg = str_replace('<Cancel>', '<input type="button" class="btn btn-success" value="' . html_attr($Translation[ 'no']) . '" onClick="window.location = \'modelle_view.php?SelectedID=' . urlencode($selected_id) . '\';">', $RetMsg);
		return $RetMsg;
	}

	sql("DELETE FROM `modelle` WHERE `id`='{$selected_id}'", $eo);

	// hook: modelle_after_delete
	if(function_exists('modelle_after_delete')) {
		$args = [];
		modelle_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='modelle' AND `pkValue`='{$selected_id}'", $eo);
}

function modelle_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('modelle', $selected_id, 'edit')) return false;

	$data = [
		'inventarnummer' => Request::val('inventarnummer', ''),
		'modellname' => Request::val('modellname', ''),
		'hersteller' => Request::val('hersteller', ''),
		'modelltyp' => Request::val('modelltyp', ''),
		'beschreibung' => br2nl(Request::val('beschreibung', '')),
		'kaufdatum' => mysql_datetime(Request::val('kaufdatum', '')),
		'erstflugdatum' => mysql_datetime(Request::val('erstflugdatum', '')),
		'gewicht' => Request::val('gewicht', ''),
		'kaufpreis' => Request::val('kaufpreis', ''),
		'technische_ausstattung' => br2nl(Request::val('technische_ausstattung', '')),
		'bild1' => Request::fileUpload('bild1', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild1', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild1', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('modelle', 'bild1', $selected_id);
			},
		]),
		'bild2' => Request::fileUpload('bild2', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild2', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild2', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('modelle', 'bild2', $selected_id);
			},
		]),
		'bild3' => Request::fileUpload('bild3', [
			'maxSize' => 2048000,
			'types' => 'jpg|jpeg|gif|png|webp',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild3', 'tv'));
				createThumbnail($name, getThumbnailSpecs('modelle', 'bild3', 'dv'));
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('modelle', 'bild3', $selected_id);
			},
		]),
		'datenblatt' => Request::fileUpload('datenblatt', [
			'maxSize' => 2048000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('modelle', 'datenblatt', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
	];

	if($data['modelltyp'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Modelltyp': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	// get existing values
	$old_data = getRecord('modelle', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: modelle_before_update
	if(function_exists('modelle_before_update')) {
		$args = ['old_data' => $old_data];
		if(!modelle_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'modelle', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="modelle_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('modelle', $data['selectedID'], calculated_fields()['modelle']);

	// hook: modelle_after_update
	if(function_exists('modelle_after_update')) {
		$res = sql("SELECT * FROM `modelle` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!modelle_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='modelle' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function modelle_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('modelle');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: modelltyp
	$combo_modelltyp = new Combo;
	$combo_modelltyp->ListType = 0;
	$combo_modelltyp->MultipleSeparator = ', ';
	$combo_modelltyp->ListBoxHeight = 10;
	$combo_modelltyp->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/modelle.modelltyp.csv')) {
		$modelltyp_data = addslashes(implode('', @file(__DIR__ . '/hooks/modelle.modelltyp.csv')));
		$combo_modelltyp->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($modelltyp_data))));
		$combo_modelltyp->ListData = $combo_modelltyp->ListItem;
	} else {
		$combo_modelltyp->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Motorflugzeug;;Segelflugzeug;;Motorsegelflugzeug;;Modellhubschrauber;;Scalemodell;;Drohne;;Sonstiges"))));
		$combo_modelltyp->ListData = $combo_modelltyp->ListItem;
	}
	$combo_modelltyp->SelectName = 'modelltyp';
	$combo_modelltyp->AllowNull = false;

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='modelle' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='modelle' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `modelle` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'modelle_view.php', false);
		}
		$combo_modelltyp->SelectedData = $row['modelltyp'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_modelltyp->SelectedText = (isset($filterField[1]) && $filterField[1] == '5' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
	}
	$combo_modelltyp->Render();

	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/modelle_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/modelle_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Mein Flugmodell', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return modelle_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return modelle_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return modelle_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#inventarnummer').replaceWith('<div class=\"form-control-static\" id=\"inventarnummer\">' + (jQuery('#inventarnummer').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#modellname').replaceWith('<div class=\"form-control-static\" id=\"modellname\">' + (jQuery('#modellname').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#hersteller').replaceWith('<div class=\"form-control-static\" id=\"hersteller\">' + (jQuery('#hersteller').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#modelltyp').replaceWith('<div class=\"form-control-static\" id=\"modelltyp\">' + (jQuery('#modelltyp').val() || '') + '</div>'); jQuery('#modelltyp-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#beschreibung').replaceWith('<div class=\"form-control-static\" id=\"beschreibung\">' + (jQuery('#beschreibung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kaufdatum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"kaufdatum\">' + (jQuery('#kaufdatum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#erstflugdatum').parents('.input-group').replaceWith('<div class=\"form-control-static\" id=\"erstflugdatum\">' + (jQuery('#erstflugdatum').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#gewicht').replaceWith('<div class=\"form-control-static\" id=\"gewicht\">' + (jQuery('#gewicht').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#kaufpreis').replaceWith('<div class=\"form-control-static\" id=\"kaufpreis\">' + (jQuery('#kaufpreis').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#technische_ausstattung').replaceWith('<div class=\"form-control-static\" id=\"technische_ausstattung\">' + (jQuery('#technische_ausstattung').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild1').replaceWith('<div class=\"form-control-static\" id=\"bild1\">' + (jQuery('#bild1').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild2').replaceWith('<div class=\"form-control-static\" id=\"bild2\">' + (jQuery('#bild2').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bild3').replaceWith('<div class=\"form-control-static\" id=\"bild3\">' + (jQuery('#bild3').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datenblatt').replaceWith('<div class=\"form-control-static\" id=\"datenblatt\">' + (jQuery('#datenblatt').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#datenblatt, #datenblatt-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#kaufdatum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$locale = isset($Translation['datetimepicker locale']) ? ", locale: '{$Translation['datetimepicker locale']}'" : '';
		$jsEditable .= "\tjQuery('#erstflugdatum').addClass('always_shown').parents('.input-group').datetimepicker({ toolbarPlacement: 'top', sideBySide: true, showClear: true, showTodayButton: true, showClose: true, icons: { close: 'glyphicon glyphicon-ok' }, format: AppGini.datetimeFormat('dt') {$locale} });";
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(modelltyp)%%>', $combo_modelltyp->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(modelltyp)%%>', $combo_modelltyp->SelectedData, $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(inventarnummer)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(modellname)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(hersteller)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(modelltyp)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(beschreibung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kaufdatum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erstflugdatum)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(gewicht)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(kaufpreis)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(technische_ausstattung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bild1)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild1" id="bild1" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild1'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '<br><input type="checkbox" name="bild1_remove" id="bild1_remove" value="1"> <label for="bild1_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild1)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild2)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild2" id="bild2" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild2'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '<br><input type="checkbox" name="bild2_remove" id="bild2_remove" value="1"> <label for="bild2_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild2)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(bild3)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="bild3" id="bild3" data-filetypes="jpg|jpeg|gif|png|webp" data-maxsize="2048000" accept=".jpg,.jpeg,.gif,.png,.webp">'), $templateCode);
	if($AllowUpdate && $row['bild3'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '<br><input type="checkbox" name="bild3_remove" id="bild3_remove" value="1"> <label for="bild3_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(bild3)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(datenblatt)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="datenblatt" id="datenblatt" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="2048000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['datenblatt'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(datenblatt)%%>', '<br><input type="checkbox" name="datenblatt_remove" id="datenblatt_remove" value="1"> <label for="datenblatt_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(datenblatt)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', safe_html($urow['inventarnummer']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(inventarnummer)%%>', html_attr($row['inventarnummer']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode($urow['inventarnummer']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', safe_html($urow['modellname']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(modellname)%%>', html_attr($row['modellname']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode($urow['modellname']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(hersteller)%%>', safe_html($urow['hersteller']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(hersteller)%%>', html_attr($row['hersteller']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(hersteller)%%>', urlencode($urow['hersteller']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(modelltyp)%%>', safe_html($urow['modelltyp']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(modelltyp)%%>', html_attr($row['modelltyp']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modelltyp)%%>', urlencode($urow['modelltyp']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(beschreibung)%%>', safe_html($urow['beschreibung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode($urow['beschreibung']), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufdatum)%%>', app_datetime($row['kaufdatum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufdatum)%%>', urlencode(app_datetime($urow['kaufdatum'], 'dt')), $templateCode);
		$templateCode = str_replace('<%%VALUE(erstflugdatum)%%>', app_datetime($row['erstflugdatum'], 'dt'), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erstflugdatum)%%>', urlencode(app_datetime($urow['erstflugdatum'], 'dt')), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(gewicht)%%>', safe_html($urow['gewicht']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(gewicht)%%>', html_attr($row['gewicht']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(gewicht)%%>', urlencode($urow['gewicht']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(kaufpreis)%%>', safe_html($urow['kaufpreis']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(kaufpreis)%%>', html_attr($row['kaufpreis']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufpreis)%%>', urlencode($urow['kaufpreis']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(technische_ausstattung)%%>', safe_html($urow['technische_ausstattung']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(technische_ausstattung)%%>', safe_html($urow['technische_ausstattung'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(technische_ausstattung)%%>', urlencode($urow['technische_ausstattung']), $templateCode);
		$row['bild1'] = ($row['bild1'] != '' ? $row['bild1'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', safe_html($urow['bild1']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild1)%%>', html_attr($row['bild1']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild1)%%>', urlencode($urow['bild1']), $templateCode);
		$row['bild2'] = ($row['bild2'] != '' ? $row['bild2'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', safe_html($urow['bild2']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild2)%%>', html_attr($row['bild2']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild2)%%>', urlencode($urow['bild2']), $templateCode);
		$row['bild3'] = ($row['bild3'] != '' ? $row['bild3'] : 'blank.gif');
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', safe_html($urow['bild3']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bild3)%%>', html_attr($row['bild3']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bild3)%%>', urlencode($urow['bild3']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(datenblatt)%%>', safe_html($urow['datenblatt']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(datenblatt)%%>', html_attr($row['datenblatt']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datenblatt)%%>', urlencode($urow['datenblatt']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(inventarnummer)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(inventarnummer)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(modellname)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modellname)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(hersteller)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(hersteller)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(modelltyp)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(modelltyp)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(beschreibung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(beschreibung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufdatum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufdatum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erstflugdatum)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erstflugdatum)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(gewicht)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(gewicht)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(kaufpreis)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(kaufpreis)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(technische_ausstattung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(technische_ausstattung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bild1)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild2)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(bild3)%%>', 'blank.gif', $templateCode);
		$templateCode = str_replace('<%%VALUE(datenblatt)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(datenblatt)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('datenblattEdit')) { document.getElementById('datenblattEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('datenblattEditLink')) { document.getElementById('datenblattEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('modelle');
	if($selected_id) {
		$jdata = get_joined_record('modelle', $selected_id);
		if($jdata === false) $jdata = get_defaults('modelle');
		$rdata = $row;
	}
	$templateCode .= loadView('modelle-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: modelle_dv
	if(function_exists('modelle_dv')) {
		$args = [];
		modelle_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}