<?php

// Data functions (insert, update, delete, form) for table ticketsystem

// This script and data application were generated by AppGini 22.14
// Download AppGini for free from https://bigprof.com/appgini/download/

function ticketsystem_insert(&$error_message = '') {
	global $Translation;

	// mm: can member insert record?
	$arrPerm = getTablePermissions('ticketsystem');
	if(!$arrPerm['insert']) return false;

	$data = [
		'bereich' => Request::val('bereich', ''),
		'art_meldung' => Request::val('art_meldung', ''),
		'meldungstext' => br2nl(Request::val('meldungstext', '')),
		'bearbeitungstext' => br2nl(Request::val('bearbeitungstext', '')),
		'file' => Request::fileUpload('file', [
			'maxSize' => 5120000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'success' => function($name, $selected_id) {
			},
			'failure' => function($selected_id, $fileRemoved) {
				if(!strlen(Request::val('SelectedID'))) return '';

				/* for empty upload fields, when saving a copy of an existing record, copy the original upload field */
				return existing_value('ticketsystem', 'file', Request::val('SelectedID'));
			},
		]),
		'erfasser' => parseCode('<%%creatorUsername%%>', true),
		'erfasst' => parseCode('<%%creationDateTime%%>', true),
		'status' => Request::val('status', ''),
	];

	if($data['bereich'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Bereich': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['art_meldung'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Art der Meldung': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['status'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Status des Tickets': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}

	// hook: ticketsystem_before_insert
	if(function_exists('ticketsystem_before_insert')) {
		$args = [];
		if(!ticketsystem_before_insert($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$error = '';
	// set empty fields to NULL
	$data = array_map(function($v) { return ($v === '' ? NULL : $v); }, $data);
	insert('ticketsystem', backtick_keys_once($data), $error);
	if($error) {
		$error_message = $error;
		return false;
	}

	$recID = db_insert_id(db_link());

	update_calc_fields('ticketsystem', $recID, calculated_fields()['ticketsystem']);

	// hook: ticketsystem_after_insert
	if(function_exists('ticketsystem_after_insert')) {
		$res = sql("SELECT * FROM `ticketsystem` WHERE `id`='" . makeSafe($recID, false) . "' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) {
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args = [];
		if(!ticketsystem_after_insert($data, getMemberInfo(), $args)) { return $recID; }
	}

	// mm: save ownership data
	set_record_owner('ticketsystem', $recID, getLoggedMemberID());

	// if this record is a copy of another record, copy children if applicable
	if(strlen(Request::val('SelectedID'))) ticketsystem_copy_children($recID, Request::val('SelectedID'));

	return $recID;
}

function ticketsystem_copy_children($destination_id, $source_id) {
	global $Translation;
	$requests = []; // array of curl handlers for launching insert requests
	$eo = ['silentErrors' => true];
	$safe_sid = makeSafe($source_id);

	// launch requests, asynchronously
	curl_batch($requests);
}

function ticketsystem_delete($selected_id, $AllowDeleteOfParents = false, $skipChecks = false) {
	// insure referential integrity ...
	global $Translation;
	$selected_id = makeSafe($selected_id);

	// mm: can member delete record?
	if(!check_record_permission('ticketsystem', $selected_id, 'delete')) {
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: ticketsystem_before_delete
	if(function_exists('ticketsystem_before_delete')) {
		$args = [];
		if(!ticketsystem_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'] . (
				!empty($args['error_message']) ?
					'<div class="text-bold">' . strip_tags($args['error_message']) . '</div>'
					: '' 
			);
	}

	sql("DELETE FROM `ticketsystem` WHERE `id`='{$selected_id}'", $eo);

	// hook: ticketsystem_after_delete
	if(function_exists('ticketsystem_after_delete')) {
		$args = [];
		ticketsystem_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("DELETE FROM `membership_userrecords` WHERE `tableName`='ticketsystem' AND `pkValue`='{$selected_id}'", $eo);
}

function ticketsystem_update(&$selected_id, &$error_message = '') {
	global $Translation;

	// mm: can member edit record?
	if(!check_record_permission('ticketsystem', $selected_id, 'edit')) return false;

	$data = [
		'bereich' => Request::val('bereich', ''),
		'art_meldung' => Request::val('art_meldung', ''),
		'meldungstext' => br2nl(Request::val('meldungstext', '')),
		'bearbeitungstext' => br2nl(Request::val('bearbeitungstext', '')),
		'file' => Request::fileUpload('file', [
			'maxSize' => 5120000,
			'types' => 'doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png',
			'noRename' => false,
			'dir' => '',
			'id' => $selected_id,
			'success' => function($name, $selected_id) {
			},
			'removeOnRequest' => true,
			'remove' => function($selected_id) {
				// do nothing: preserve removed files on server.
			},
			'failure' => function($selected_id, $fileRemoved) {
				if($fileRemoved) return '';
				return existing_value('ticketsystem', 'file', $selected_id);
			},
		]),
		'geaendert_von' => parseCode('<%%editorUsername%%>', false),
		'geaendert' => parseCode('<%%editingDateTime%%>', false),
		'status' => Request::val('status', ''),
	];

	if($data['bereich'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Bereich': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['art_meldung'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Art der Meldung': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	if($data['status'] === '') {
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Status des Tickets': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">' . $Translation['< back'] . '</a></div>';
		exit;
	}
	// get existing values
	$old_data = getRecord('ticketsystem', $selected_id);
	if(is_array($old_data)) {
		$old_data = array_map('makeSafe', $old_data);
		$old_data['selectedID'] = makeSafe($selected_id);
	}

	$data['selectedID'] = makeSafe($selected_id);

	// hook: ticketsystem_before_update
	if(function_exists('ticketsystem_before_update')) {
		$args = ['old_data' => $old_data];
		if(!ticketsystem_before_update($data, getMemberInfo(), $args)) {
			if(isset($args['error_message'])) $error_message = $args['error_message'];
			return false;
		}
	}

	$set = $data; unset($set['selectedID']);
	foreach ($set as $field => $value) {
		$set[$field] = ($value !== '' && $value !== NULL) ? $value : NULL;
	}

	if(!update(
		'ticketsystem', 
		backtick_keys_once($set), 
		['`id`' => $selected_id], 
		$error_message
	)) {
		echo $error_message;
		echo '<a href="ticketsystem_view.php?SelectedID=' . urlencode($selected_id) . "\">{$Translation['< back']}</a>";
		exit;
	}


	$eo = ['silentErrors' => true];

	update_calc_fields('ticketsystem', $data['selectedID'], calculated_fields()['ticketsystem']);

	// hook: ticketsystem_after_update
	if(function_exists('ticketsystem_after_update')) {
		$res = sql("SELECT * FROM `ticketsystem` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)) $data = array_map('makeSafe', $row);

		$data['selectedID'] = $data['id'];
		$args = ['old_data' => $old_data];
		if(!ticketsystem_after_update($data, getMemberInfo(), $args)) return;
	}

	// mm: update ownership data
	sql("UPDATE `membership_userrecords` SET `dateUpdated`='" . time() . "' WHERE `tableName`='ticketsystem' AND `pkValue`='" . makeSafe($selected_id) . "'", $eo);
}

function ticketsystem_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $separateDV = 0, $TemplateDV = '', $TemplateDVP = '') {
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;
	$eo = ['silentErrors' => true];
	$noUploads = null;
	$row = $urow = $jsReadOnly = $jsEditable = $lookups = null;

	$noSaveAsCopy = true;

	// mm: get table permissions
	$arrPerm = getTablePermissions('ticketsystem');
	if(!$arrPerm['insert'] && $selected_id == '')
		// no insert permission and no record selected
		// so show access denied error unless TVDV
		return $separateDV ? $Translation['tableAccessDenied'] : '';
	$AllowInsert = ($arrPerm['insert'] ? true : false);
	// print preview?
	$dvprint = false;
	if(strlen($selected_id) && Request::val('dvprint_x') != '') {
		$dvprint = true;
	}


	// populate filterers, starting from children to grand-parents

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: bereich
	$combo_bereich = new Combo;
	$combo_bereich->ListType = 0;
	$combo_bereich->MultipleSeparator = ', ';
	$combo_bereich->ListBoxHeight = 10;
	$combo_bereich->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/ticketsystem.bereich.csv')) {
		$bereich_data = addslashes(implode('', @file(__DIR__ . '/hooks/ticketsystem.bereich.csv')));
		$combo_bereich->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($bereich_data))));
		$combo_bereich->ListData = $combo_bereich->ListItem;
	} else {
		$combo_bereich->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Allgemein;;Flugpl&#228;tze in &#214;sterreich;;Vereinsflugbuch;;Gastflugbuch;;Meine Dokumente;;Meine Modelle;;Meine Checklisten;;Meine Modellbetriebskartei;;technisches System"))));
		$combo_bereich->ListData = $combo_bereich->ListItem;
	}
	$combo_bereich->SelectName = 'bereich';
	$combo_bereich->AllowNull = false;
	// combobox: art_meldung
	$combo_art_meldung = new Combo;
	$combo_art_meldung->ListType = 0;
	$combo_art_meldung->MultipleSeparator = ', ';
	$combo_art_meldung->ListBoxHeight = 10;
	$combo_art_meldung->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/ticketsystem.art_meldung.csv')) {
		$art_meldung_data = addslashes(implode('', @file(__DIR__ . '/hooks/ticketsystem.art_meldung.csv')));
		$combo_art_meldung->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($art_meldung_data))));
		$combo_art_meldung->ListData = $combo_art_meldung->ListItem;
	} else {
		$combo_art_meldung->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Fehler;;Adaptierung;;Zusatzwunsch;;Systemkritisch;;Datensicherheit;;Anmerkung"))));
		$combo_art_meldung->ListData = $combo_art_meldung->ListItem;
	}
	$combo_art_meldung->SelectName = 'art_meldung';
	$combo_art_meldung->AllowNull = false;
	// combobox: status
	$combo_status = new Combo;
	$combo_status->ListType = 0;
	$combo_status->MultipleSeparator = ', ';
	$combo_status->ListBoxHeight = 10;
	$combo_status->RadiosPerLine = 1;
	if(is_file(__DIR__ . '/hooks/ticketsystem.status.csv')) {
		$status_data = addslashes(implode('', @file(__DIR__ . '/hooks/ticketsystem.status.csv')));
		$combo_status->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions($status_data))));
		$combo_status->ListData = $combo_status->ListItem;
	} else {
		$combo_status->ListItem = array_trim(explode('||', entitiesToUTF8(convertLegacyOptions("Erfasst;;in Bearbeitung;;on hold;;abgeschlossen"))));
		$combo_status->ListData = $combo_status->ListItem;
	}
	$combo_status->SelectName = 'status';
	$combo_status->AllowNull = false;

	if($selected_id) {
		// mm: check member permissions
		if(!$arrPerm['view']) return $Translation['tableAccessDenied'];

		// mm: who is the owner?
		$ownerGroupID = sqlValue("SELECT `groupID` FROM `membership_userrecords` WHERE `tableName`='ticketsystem' AND `pkValue`='" . makeSafe($selected_id) . "'");
		$ownerMemberID = sqlValue("SELECT LCASE(`memberID`) FROM `membership_userrecords` WHERE `tableName`='ticketsystem' AND `pkValue`='" . makeSafe($selected_id) . "'");

		if($arrPerm['view'] == 1 && getLoggedMemberID() != $ownerMemberID) return $Translation['tableAccessDenied'];
		if($arrPerm['view'] == 2 && getLoggedGroupID() != $ownerGroupID) return $Translation['tableAccessDenied'];

		// can edit?
		$AllowUpdate = 0;
		if(($arrPerm['edit'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['edit'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['edit'] == 3) {
			$AllowUpdate = 1;
		}

		$res = sql("SELECT * FROM `ticketsystem` WHERE `id`='" . makeSafe($selected_id) . "'", $eo);
		if(!($row = db_fetch_array($res))) {
			return error_message($Translation['No records found'], 'ticketsystem_view.php', false);
		}
		$combo_bereich->SelectedData = $row['bereich'];
		$combo_art_meldung->SelectedData = $row['art_meldung'];
		$combo_status->SelectedData = $row['status'];
		$urow = $row; /* unsanitized data */
		$row = array_map('safe_html', $row);
	} else {
		$filterField = Request::val('FilterField');
		$filterOperator = Request::val('FilterOperator');
		$filterValue = Request::val('FilterValue');
		$combo_bereich->SelectedText = (isset($filterField[1]) && $filterField[1] == '2' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
		$combo_art_meldung->SelectedText = (isset($filterField[1]) && $filterField[1] == '3' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
		$combo_status->SelectedText = (isset($filterField[1]) && $filterField[1] == '11' && $filterOperator[1] == '<=>' ? $filterValue[1] : '');
	}
	$combo_bereich->Render();
	$combo_art_meldung->Render();
	$combo_status->Render();

	ob_start();
	?>

	<script>
		// initial lookup values

		jQuery(function() {
			setTimeout(function() {
			}, 50); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_clean());


	// code for template based detail view forms

	// open the detail view template
	if($dvprint) {
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/ticketsystem_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	} else {
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/ticketsystem_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Ticket', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', (Request::val('Embedded') ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($arrPerm['insert'] && !$selected_id) { // allow insert and no record selected?
		if(!$selected_id) $templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return ticketsystem_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return ticketsystem_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if(Request::val('Embedded')) {
		$backAction = 'AppGini.closeParentModal(); return false;';
	} else {
		$backAction = '$j(\'form\').eq(0).attr(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id) {
		if(!Request::val('Embedded')) $templateCode = str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$j(\'form\').eq(0).prop(\'novalidate\', true); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate) {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return ticketsystem_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm['delete'] == 1 && $ownerMemberID == getLoggedMemberID()) || ($arrPerm['delete'] == 2 && $ownerGroupID == getLoggedGroupID()) || $arrPerm['delete'] == 3) { // allow delete?
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		} else {
			$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	} else {
		$templateCode = str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode = str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);

		// if not in embedded mode and user has insert only but no view/update/delete,
		// remove 'back' button
		if(
			$arrPerm['insert']
			&& !$arrPerm['update'] && !$arrPerm['delete'] && !$arrPerm['view']
			&& !Request::val('Embedded')
		)
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
		elseif($separateDV)
			$templateCode = str_replace(
				'<%%DESELECT_BUTTON%%>', 
				'<button
					type="submit" 
					class="btn btn-default" 
					id="deselect" 
					name="deselect_x" 
					value="1" 
					onclick="' . $backAction . '" 
					title="' . html_attr($Translation['Back']) . '">
						<i class="glyphicon glyphicon-chevron-left"></i> ' .
						$Translation['Back'] .
				'</button>',
				$templateCode
			);
		else
			$templateCode = str_replace('<%%DESELECT_BUTTON%%>', '', $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate) || (!$selected_id && !$AllowInsert)) {
		$jsReadOnly = '';
		$jsReadOnly .= "\tjQuery('#bereich').replaceWith('<div class=\"form-control-static\" id=\"bereich\">' + (jQuery('#bereich').val() || '') + '</div>'); jQuery('#bereich-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#art_meldung').replaceWith('<div class=\"form-control-static\" id=\"art_meldung\">' + (jQuery('#art_meldung').val() || '') + '</div>'); jQuery('#art_meldung-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('#meldungstext').replaceWith('<div class=\"form-control-static\" id=\"meldungstext\">' + (jQuery('#meldungstext').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#bearbeitungstext').replaceWith('<div class=\"form-control-static\" id=\"bearbeitungstext\">' + (jQuery('#bearbeitungstext').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#file').replaceWith('<div class=\"form-control-static\" id=\"file\">' + (jQuery('#file').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('#file, #file-edit-link').hide();\n";
		$jsReadOnly .= "\tjQuery('#status').replaceWith('<div class=\"form-control-static\" id=\"status\">' + (jQuery('#status').val() || '') + '</div>'); jQuery('#status-multi-selection-help').hide();\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	} elseif(($AllowInsert && !$selected_id) || ($AllowUpdate && $selected_id)) {
		$jsEditable = "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode = str_replace('<%%COMBO(bereich)%%>', $combo_bereich->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(bereich)%%>', $combo_bereich->SelectedData, $templateCode);
	$templateCode = str_replace('<%%COMBO(art_meldung)%%>', $combo_art_meldung->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(art_meldung)%%>', $combo_art_meldung->SelectedData, $templateCode);
	$templateCode = str_replace('<%%COMBO(status)%%>', $combo_status->HTML, $templateCode);
	$templateCode = str_replace('<%%COMBOTEXT(status)%%>', $combo_status->SelectedData, $templateCode);

	/* lookup fields array: 'lookup field name' => ['parent table name', 'lookup field caption'] */
	$lookup_fields = [];
	foreach($lookup_fields as $luf => $ptfc) {
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']) {
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] /* && !Request::val('Embedded')*/) {
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-default add_new_parent" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus text-success"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode = str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bereich)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(art_meldung)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(meldungstext)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(bearbeitungstext)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(file)%%>', ($noUploads ? '' : "<div>{$Translation['upload image']}</div>" . '<i class="glyphicon glyphicon-remove text-danger clear-upload hidden"></i> <input type="file" name="file" id="file" data-filetypes="doc|docx|docm|odt|pdf|xls|xlsx|zip|jpg|jpeg|gif|png" data-maxsize="5120000" accept=".doc,.docx,.docm,.odt,.pdf,.xls,.xlsx,.zip,.jpg,.jpeg,.gif,.png">'), $templateCode);
	if($AllowUpdate && $row['file'] != '') {
		$templateCode = str_replace('<%%REMOVEFILE(file)%%>', '<br><input type="checkbox" name="file_remove" id="file_remove" value="1"> <label for="file_remove" style="color: red; font-weight: bold;">'.$Translation['remove image'].'</label>', $templateCode);
	} else {
		$templateCode = str_replace('<%%REMOVEFILE(file)%%>', '', $templateCode);
	}
	$templateCode = str_replace('<%%UPLOADFILE(erfasser)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(erfasst)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert_von)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(geaendert)%%>', '', $templateCode);
	$templateCode = str_replace('<%%UPLOADFILE(status)%%>', '', $templateCode);

	// process values
	if($selected_id) {
		if( $dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', safe_html($urow['id']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(bereich)%%>', safe_html($urow['bereich']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(bereich)%%>', html_attr($row['bereich']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bereich)%%>', urlencode($urow['bereich']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(art_meldung)%%>', safe_html($urow['art_meldung']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(art_meldung)%%>', html_attr($row['art_meldung']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(art_meldung)%%>', urlencode($urow['art_meldung']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(meldungstext)%%>', safe_html($urow['meldungstext']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(meldungstext)%%>', safe_html($urow['meldungstext'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(meldungstext)%%>', urlencode($urow['meldungstext']), $templateCode);
		if($dvprint || (!$AllowUpdate && !$AllowInsert)) {
			$templateCode = str_replace('<%%VALUE(bearbeitungstext)%%>', safe_html($urow['bearbeitungstext']), $templateCode);
		} else {
			$templateCode = str_replace('<%%VALUE(bearbeitungstext)%%>', safe_html($urow['bearbeitungstext'], true), $templateCode);
		}
		$templateCode = str_replace('<%%URLVALUE(bearbeitungstext)%%>', urlencode($urow['bearbeitungstext']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(file)%%>', safe_html($urow['file']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(file)%%>', html_attr($row['file']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(file)%%>', urlencode($urow['file']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', safe_html($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode($urow['erfasser']), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', safe_html($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode($urow['erfasst']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', safe_html($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode($urow['geaendert_von']), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', safe_html($urow['geaendert']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode($urow['geaendert']), $templateCode);
		if( $dvprint) $templateCode = str_replace('<%%VALUE(status)%%>', safe_html($urow['status']), $templateCode);
		if(!$dvprint) $templateCode = str_replace('<%%VALUE(status)%%>', html_attr($row['status']), $templateCode);
		$templateCode = str_replace('<%%URLVALUE(status)%%>', urlencode($urow['status']), $templateCode);
	} else {
		$templateCode = str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bereich)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bereich)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(art_meldung)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(art_meldung)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(meldungstext)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(meldungstext)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(bearbeitungstext)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(bearbeitungstext)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(file)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(file)%%>', urlencode(''), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasser)%%>', '<%%creatorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasser)%%>', urlencode('<%%creatorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(erfasst)%%>', '<%%creationDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(erfasst)%%>', urlencode('<%%creationDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert_von)%%>', '<%%editorUsername%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert_von)%%>', urlencode('<%%editorUsername%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(geaendert)%%>', '<%%editingDateTime%%>', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(geaendert)%%>', urlencode('<%%editingDateTime%%>'), $templateCode);
		$templateCode = str_replace('<%%VALUE(status)%%>', '', $templateCode);
		$templateCode = str_replace('<%%URLVALUE(status)%%>', urlencode(''), $templateCode);
	}

	// process translations
	$templateCode = parseTemplate($templateCode);

	// clear scrap
	$templateCode = str_replace('<%%', '<!-- ', $templateCode);
	$templateCode = str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if(Request::val('dvprint_x') == '') {
		$templateCode .= "\n\n<script>\$j(function() {\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption) {
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id) {
			$templateCode.="\n\tif(document.getElementById('fileEdit')) { document.getElementById('fileEdit').style.display='inline'; }";
			$templateCode.="\n\tif(document.getElementById('fileEditLink')) { document.getElementById('fileEditLink').style.display='none'; }";
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields
	$filterField = Request::val('FilterField');
	$filterOperator = Request::val('FilterOperator');
	$filterValue = Request::val('FilterValue');

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('ticketsystem');
	if($selected_id) {
		$jdata = get_joined_record('ticketsystem', $selected_id);
		if($jdata === false) $jdata = get_defaults('ticketsystem');
		$rdata = $row;
	}
	$templateCode .= loadView('ticketsystem-ajax-cache', ['rdata' => $rdata, 'jdata' => $jdata]);

	// hook: ticketsystem_dv
	if(function_exists('ticketsystem_dv')) {
		$args = [];
		ticketsystem_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}